#ifndef __DO_RMAHDR_
#define __DO_RMAHDR_

#ifdef __cplusplus
  extern "C" {
#endif

#define VCS_RTLIB_TLS_MODEL  __attribute__((tls_model("initial-exec")))

typedef unsigned long UP;
typedef unsigned U;
typedef unsigned char UB;
typedef unsigned short US;
typedef unsigned long long ULL;
typedef unsigned char scalar;
typedef struct vec32 vec32;
typedef unsigned char SVAL;
typedef unsigned char TYPEB;
typedef struct etype ETYPE;
typedef struct qird QIRD;
typedef unsigned char UST_e;
typedef unsigned uscope_t;
typedef U  NumLibs_t;
struct vec32 {
    U  I1;
    U  I2;
};
typedef unsigned long long InstNumType;
typedef long long InstNumSigned;
typedef InstNumType  InstNum;
typedef U  InstNum32;
typedef unsigned long RP;
typedef unsigned long RO;
typedef U  GateCount;
typedef U  NodeCount;
typedef unsigned short HsimEdge;
typedef unsigned char HsimExprChar;
typedef struct {
    U  I646;
    RP  I647;
} RmaReceiveClock1;
typedef NodeCount  FlatNodeNum;
typedef unsigned ProcessNum;
typedef unsigned long long TimeStamp64;
typedef unsigned long long TimeStamp;
typedef enum {
    PD_SING = 0,
    PD_RF = 1,
    PD_PLSE = 2,
    PD_PLSE_RF = 3,
    PD_NULL = 4
} PD_e;
typedef TimeStamp64  RmaTimeStamp64;
typedef TimeStamp  RmaTimeStamp;
typedef union {
    double I654;
    unsigned long long I655;
    unsigned  I656[2];
} rma_clock_struct;
typedef struct eblk EBLK;
typedef int (* E_fn)(void);
typedef struct eblk {
    E_fn  I663;
    struct iptmpl * I664;
    struct eblk * I666;
    unsigned I667;
    unsigned I668;
    struct eblk * I669;
} eblk_struct;
typedef struct {
    RP  I663;
    RP  I664;
    RP  I666;
    unsigned I667;
    unsigned I668;
    RP  I669;
} RmaEblk;
typedef struct {
    RP  I663;
    RP  I664;
    RP  I666;
    unsigned I667;
    unsigned I668;
    RP  I669;
    unsigned val;
} RmaEblklq;
typedef struct _DEblkLaneT {
    struct _DEblkLaneT * I676;
    struct eblk * I678;
} DEblkLaneT;
typedef struct _DEblkPoolT {
    struct _DEblkLaneT * I679;
    struct _DEblkLaneT * I680;
    unsigned I681;
    unsigned I682;
} DEblkPoolT;
typedef union {
    double I654;
    unsigned long long I655;
    unsigned  I656[2];
} clock_struct;
typedef struct RmaRetain_t RmaRetain;
struct RmaRetain_t {
    RP  I713;
    RmaEblk  I662;
    U  I715;
    US  I716 :1;
    US  I717 :4;
    US  I234 :2;
    US  state :2;
    US  I719 :1;
    US  I720 :2;
    US  I721 :2;
    US  fHsim :1;
    US  I560 :1;
    scalar  newval;
    scalar  I724;
    RP  I725;
};
struct retain_t {
    struct retain_t * I713;
    EBLK  I662;
    U  I715;
    US  I716 :1;
    US  I717 :4;
    US  I234 :2;
    US  state :2;
    US  I719 :1;
    US  I720 :2;
    US  I721 :2;
    US  fHsim :1;
    US  I722 :1;
    scalar  newval;
    scalar  I724;
    void * I725;
};
typedef struct MPSched MPS;
typedef struct RmaMPSched RmaMps;
struct MPSched {
    MPS  * I704;
    scalar  I705;
    scalar  I706;
    scalar  I707;
    scalar  fHsim :1;
    scalar  I234 :6;
    U  I709;
    EBLK  I710;
    void * I711;
    UP   I712[1];
};
struct RmaMPSched {
    RP  I704;
    scalar  I705;
    scalar  I706;
    scalar  I707;
    scalar  fHsim :1;
    scalar  I234 :6;
    U  I709;
    RmaEblk  I710;
    RP  I711;
    RP   I712[1];
};
typedef struct RmaMPSchedPulse RmaMpsp;
struct RmaMPSchedPulse {
    RP  I704;
    scalar  I705;
    scalar  I706;
    scalar  I707;
    scalar  I234;
    U  I709;
    RmaEblk  I710;
    scalar  I721;
    scalar  I730;
    scalar  I731;
    scalar  I732;
    U  I733;
    U  I734;
    U  I735;
    U  state;
    U  I736;
    RP  I664;
    RP  I737;
    RP  I738;
    RP   I712[1];
};
typedef struct MPItem MPI;
struct MPItem {
    U  * I740;
    void * I741;
};
typedef struct {
    RmaEblk  I662;
    RP  I742;
    scalar  I743;
    scalar  I721;
    scalar  I744;
} RmaTransEventHdr;
typedef struct RmaMPSchedPulseNewCsdf RmaMpspNewCsdf;
struct RmaMPSchedPulseNewCsdf {
    RP  I704;
    scalar  I705;
    scalar  I706;
    scalar  I707;
    scalar  fHsim :1;
    scalar  I234 :6;
    U  I709;
    RmaEblk  I710;
    scalar  I721;
    scalar  I730;
    scalar  I731;
    scalar  I732;
    U  state :4;
    U  I746 :28;
    U  I734;
    U  I735;
    RP  I747;
    RP  I664;
    RP  I748;
    RP   I712[1];
};
typedef struct red_t {
    U  I749;
    U  I750;
    U  I624;
} RED;
typedef struct predd {
    PD_e  I234;
    RED   I751[0];
} PREDD;
union rhs_value {
    vec32  I752;
    scalar  I743;
    vec32  * I721;
    double I753;
    U  I754;
};
typedef struct nbs_t {
    struct nbs_t * I755;
    struct nbs_t * I757;
    void (* I758)(struct nbs_t * I725);
    U  I759 :1;
    U  I760 :1;
    U  I761 :1;
    U  I762 :1;
    U  I763 :1;
    U  I764 :1;
    U  I765 :26;
    U  I766;
    void * I767;
    union rhs_value I768;
    vec32  I654;
    union {
        struct nbs_t * I1235;
        struct nbs_t * last;
    } I770;
} NBS;
typedef struct {
    RP  I771;
    RP  I737;
    RP  I664;
    RP  I738;
    RmaEblk  I662;
    RmaEblk  I772;
    RP  I773;
    scalar  I743;
    scalar  I721;
    char state;
    uscope_t  I774;
    U  I775;
    RP  I776;
    scalar  I730;
    scalar  I731;
    scalar  I732;
    U  I734;
    U  I735;
    RP  I711;
} RmaPulse;
typedef enum {
    QIRDModuleC = 1,
    QIRDSVPackageC = 2,
    QIRDSpiceModuleC = 3
} QIRDModuleType;
typedef struct {
    U  I780 :1;
    U  I781 :1;
    U  I782 :1;
    U  I783 :1;
    U  I784 :1;
    U  I785 :1;
    U  I786 :1;
    U  I787 :1;
    U  I788 :1;
    U  I789 :1;
    U  I790 :1;
    U  I791 :1;
    U  I792 :1;
    U  I793 :1;
    U  I794 :1;
    U  I795 :1;
    U  I796 :1;
    U  I797 :1;
    U  I798 :1;
    QIRDModuleType  I799 :2;
    U  I800 :1;
    U  I801 :1;
    U  I802 :1;
    U  I803 :1;
    U  I804 :1;
    U  I805 :1;
    U  I806 :1;
    U  I807 :1;
    U  I808 :1;
    U  I809 :1;
    U  I810 :1;
    U  I811 :1;
    U  I812 :1;
    U  I813 :1;
    U  I814 :1;
    U  I815 :1;
    U  I816 :1;
    U  I817 :1;
    U  I818 :1;
    U  I819 :1;
    U  I820 :1;
    U  I821 :1;
    U  I822 :1;
    U  I823 :1;
    U  I824 :1;
    U  I825 :1;
    U  I826 :1;
    U  I827 :1;
    U  I828 :1;
    U  I829 :1;
    U  I830 :1;
    U  I831 :1;
} BitFlags;
typedef struct qird_dbg_flags_s {
    U  I832 :29;
    U  I833 :1;
    U  I834 :1;
    U  I835 :1;
} qird_dbg_flags_t;
typedef struct nlpInfoT {
    U  * I836;
    U  * I837;
    U  * I838;
    UP  * I839;
    UP  * I840;
    UP  * I841;
    UP  * I842;
    char * I843;
    UP  * I844;
    UP  * I845;
    U  * I846;
    UP  * I847;
    UP  * I848;
    UP  * I849;
    UP  * I850;
    UP  * I851;
    UP  * I852;
    UP  * I853;
    UP  * I854;
    UP  * I855;
    UP  * I856;
    UP  * I857;
    UP  * I858;
    UP  * I859;
    UP  * I860;
    char * I861;
    char * I862;
    U  * I863;
    U  * I864;
    U  * I865;
    UP  * I866;
    UP  * I867;
    UP  * I868;
    UP  * I869;
    UP  * I870;
    UP  * I871;
    UP  * I872;
    UP  * I873;
    UP  * I874;
    UP  * I875;
    UP  * I876;
    UP  * I877;
    U  I878;
    U  I879;
    U  I880;
    U  I881;
    U  I882;
    U  I883;
    U  I884;
    U  I885;
    U  I886;
    U  I887;
    U  I888;
    U  I889;
    U  I890;
    U  I891;
    U  I892;
    U  I893;
    U  I894;
    U  I895;
} nlpInfoT;
typedef struct txpInfoT {
    U  I896;
    U  I897;
    void * I898;
    void * I899;
    int (* I900)(void);
    int (* I901)(void);
    void * I902;
    void * I903;
    void * I904;
} txpInfoT;
typedef struct fsimInfoT {
    U  I905;
    U  I906;
    U  * I907;
    U  * I908;
    UP  * I909;
    UP  * I910;
    U  * I911;
    U  * I912;
    U  * I913;
} fsimInfoT;
typedef struct fgpInfoT {
    U  I914;
    U  I915;
    U  * I916;
    U  * I917;
    char * I918;
} fgpInfoT;
typedef struct simProfInfoT {
    U  I919;
    U  I920;
    U  I921;
    U  * I922;
    U  * I923;
    U  * I924;
    U  * I925;
} simProfInfoT;
typedef struct hybridSimInfoT {
    U  I926;
    U  I627;
    U  I927;
    U  I928;
    U  I929;
    void * I930;
    U  * I931;
    struct hybridSimReferrerData * I932;
    struct hybridSimReferrerData * I934;
} hybridSimInfoT;
typedef struct classInfoT {
    void * I935;
    void * I936;
    void * I937;
    U  I938;
    U  I939;
    U  I940;
    U  I941;
    UP  I942;
    UP  I943;
    void * I944;
} classInfoT;
struct qird {
    US  I58;
    US  I59;
    U  I60;
    U  I61;
    char * I62;
    char * I63;
    U  * I64;
    char * I65;
    char * I66;
    U  I67;
    U  I68;
    struct vcd_rt * I69;
    U  I71;
    struct _vcdOffset_rt * I72;
    U  I74;
    U  I75;
    ETYPE  * I76;
    U  * I77;
    classInfoT  * I78;
    int I79;
    U  I80;
    U  * I81;
    U  * I82;
    UP  I83;
    UP  * I84;
    BitFlags  I85;
    U  I86;
    U  I87;
    U  I88;
    U  I89;
    U  * I90;
    U  I91;
    U  I92;
    U  * I93;
    U  I94;
    U  I95;
    U  I96;
    U  I97;
    U  I98;
    U  I99;
    U  I100;
    U  I101;
    U  * I102;
    U  * I103;
    U  * I104;
    U  I105;
    U  I106;
    U  * I107;
    U  I108;
    U  I109;
    U  I110;
    U  I111;
    U  * I112;
    U  I113;
    U  * I114;
    U  I115;
    U  I116;
    U  I117;
    U  I118;
    U  I119;
    U  I120;
    U  * I121;
    char * I122;
    U  I123;
    U  I124;
    U  I125;
    U  I126;
    U  * I127;
    U  I128;
    U  I129;
    U  I130;
    U  I131;
    UP  * I132;
    U  I133;
    U  I134;
    U  I135;
    U  I136;
    U  I137;
    U  I138;
    U  * I139;
    U  I140;
    U  I141;
    U  * I142;
    U  * I143;
    U  * I144;
    U  * I145;
    U  * I146;
    U  I147;
    U  I148;
    struct taskInfo * I149;
    U  I151;
    U  I152;
    U  I153;
    U  I154;
    int * I155;
    U  * I156;
    UP  * I157;
    U  * I158;
    U  I159;
    U  I160;
    int * I161;
    U  I162;
    U  I163;
    U  I164;
    U  I165;
    U  I166;
    U  I167;
    struct qrefer * I168;
    U  * I170;
    unsigned * I171;
    void * I172;
    U  I173;
    struct classStaticReferData * I174;
    U  I176;
    U  * I177;
    U  I178;
    U  * I179;
    U  I180;
    struct wakeupInfoStruct * I181;
    U  I183;
    U  I184;
    U  I185;
    U  * I186;
    U  I187;
    U  * I188;
    U  * I189;
    U  I190;
    U  I191;
    U  I192;
    U  I193;
    U  * I194;
    U  I195;
    U  I196;
    U  * I197;
    U  I198;
    U  I199;
    U  * I200;
    U  * I201;
    U  * I202;
    U  I203;
    U  I204;
    U  I205;
    U  I206;
    U  I207;
    U  I208;
    struct qdefrefee * I209;
    struct qrefee * I211;
    U  * I213;
    U  * I214;
    int (* I215)(void);
    char * I216;
    U  I217;
    U  I218;
    void * I219;
    void * I220;
    NumLibs_t  I221;
    char * I222;
    U  * I223;
    U  I224;
    U  I225;
    U  I226;
    U  I227;
    U  I228;
    U  * I229;
    U  * I230;
    int I231;
    struct clock_load * I232;
    int I247;
    struct clock_data * I248;
    int I264;
    struct clock_hiconn * I265;
    U  I269;
    U  I270;
    U  I271;
    U  I272;
    U  * I273;
    U  I274;
    U  I275;
    U  * I276;
    U  I277;
    void * I278;
    U  I279;
    U  I280;
    UP  * I281;
    void * I282;
    U  I283;
    UP  * I284;
    U  * I285;
    int (* I286)(void);
    U  * I287;
    UP  * I288;
    U  * I289;
    U  I290 :1;
    U  I291 :31;
    U  I292;
    U  I293;
    UP  * I294;
    U  * I295;
    U  I296 :1;
    U  I297 :1;
    U  I298 :1;
    U  I299 :1;
    U  I300 :28;
    U  I301;
    U  I302;
    U  I303;
    U  I304 :31;
    U  I305 :1;
    UP  * I306;
    UP  * I307;
    fsimInfoT  * I308;
    nlpInfoT  * I309;
    U  I310;
    U  I311;
    UP  * I312;
    UP  * I313;
    UP  * I314;
    UP  * I315;
    struct daidirInfo * I316;
    struct vcs_tftable * I318;
    U  I320;
    UP  * I321;
    UP  * I322;
    U  I323;
    U  I324;
    U  I325;
    UP  * I326;
    U  * I327;
    UP  * I328;
    UP  * I329;
    struct qird_hil_data * I330;
    U  I332;
    U  * I333;
    UP  (* I334)(void);
    UP  (* I335)(void);
    UP  (* I336)(void);
    UP  (* I337)(void);
    UP  (* I338)(void);
    int * I339;
    int (* I340)(void);
    char * I341;
    UP  * I342;
    UP  * I343;
    UP  (* I344)(void);
    int (* I345)(void);
    int * I346;
    int (* I347)(void);
    int * I348;
    char * I349;
    U  * I350;
    U  * I351;
    U  * I352;
    U  * I353;
    void * I354;
    int (* I355)(void);
    U  I356;
    UP  * I357;
    UP  * I358;
    U  I359;
    void * I360;
    U  I361;
    U  I362;
    U  I363;
    U  I364;
    U  I365;
    U  I366;
    char * I367;
    UP  * I368;
    U  * I369;
    UP  * I370;
    U  * I371;
    U  * I372;
    U  I373 :15;
    U  I374 :14;
    U  I375 :1;
    U  I376 :1;
    U  I377 :1;
    U  I378 :3;
    U  I379 :1;
    U  I380 :1;
    U  I381 :17;
    U  I382 :3;
    U  I383 :5;
    U  I384 :1;
    U  I385 :1;
    U  I386;
    qird_dbg_flags_t  I387;
    struct scope * I388;
    U  I390;
    U  I391;
    U  I392;
    U  * I393;
    U  * I394;
    U  * I395;
    U  I396;
    U  I397;
    U  I398;
    U  I399;
    struct pcbt * I400;
    UP  * I409;
    U  I410;
    U  I411;
    U  I412;
    U  I413;
    void * I414;
    void * I415;
    void * I416;
    int I417;
    U  * I418;
    U  I419;
    U  I420;
    UP  * I421;
    U  I422;
    U  I423;
    U  I424;
    U  I425;
    U  I426;
    void * I427;
    UP  * I428;
    U  I429;
    U  I430;
    void * I431;
    U  I432;
    txpInfoT  * I433;
    U  I434;
    U  I435;
    U  I436;
    U  I437;
    U  I438;
    U  I439;
    char * I440;
    U  I441;
    U  * I442;
    U  I443;
    U  * I444;
    U  I445;
    U  I446;
    U  I447;
    U  I448;
    U  I449;
    U  I450;
    U  * I451;
    U  I452;
    U  I453;
    U  * I454;
    U  I455;
    U  I456;
    U  I457;
    U  * I458;
    char * I459;
    U  I460;
    U  I461;
    U  I462;
    simProfInfoT  * I463;
    U  I464;
    U  I465;
    UP  * I466;
    U  I467;
    U  I468;
    U  I469;
    struct cosim_info * I470;
    U  I472;
    U  * I473;
    hybridSimInfoT  * I474;
    U  I475;
    U  * I476;
    U  I477;
    U  I478;
    U  * I479;
    U  I480;
    U  * I481;
    U  I482;
    U  * I483;
    U  I484;
    U  I485;
    U  * I486;
    U  I487;
    U  * I488;
    U  I489;
    U  I490;
    U  * I491;
    struct mhdl_outInfo * I492;
    UP  * I494;
    U  I495;
    UP  * I496;
    U  I497;
    void * I498;
    U  * I499;
    void * I500;
    char * I501;
    U  I502;
    U  * I503;
    char * I504;
    U  I505;
    struct regInitInfo * I506;
    UP  * I508;
    U  * I509;
    char * I510;
    U  I511;
    U  I512;
    U  I513;
    U  I514;
    U  I515;
    U  I516;
    U  I517;
    U  I518;
    UP  * I519;
    U  I520;
    U  I521;
    U  I522;
    UP  * I523;
    U  I524;
    UP  * I525;
    U  I526;
    UP  * I527;
    U  I528;
    U  I529;
    U  I530;
    U  * I531;
    U  I532;
    U  I533;
    U  I534;
    U  * I535;
    U  * I536;
    UP  * I537;
    UP  * I538;
    void * I539;
    UP  I540;
    void * I541;
    void * I542;
    void * I543;
    void * I544;
    void * I545;
    UP  I546;
    U  * I547;
    U  * I548;
    void * I549;
    U  I550 :1;
    U  I551 :31;
    U  I552;
    U  I553;
    U  I554;
    int I555;
    U  I556 :1;
    U  I557 :1;
    U  I558 :1;
    U  I559 :1;
    U  I560 :28;
    void * I561;
    void * I562;
    void * I563;
    void * I564;
    void * I565;
    void * I566;
    void * I567;
    UP  * I568;
    U  * I569;
    U  I570;
    char * I571;
    U  * I572;
    U  * I573;
    U  * I574;
    char * I575;
    int * I576;
    int * I577;
    UP  * I578;
    struct etype * I579;
    U  I580;
    U  I581;
    U  * I582;
    struct etype * I583;
    U  I584;
    U  I585;
    U  I586;
    U  * I587;
    void * I588;
    U  I589;
    U  I590;
    void * I591;
    fgpInfoT  * I592;
    U  I593;
    struct covreg_rt * I594;
    U  I596;
    U  I597;
    U  * I598;
    U  I599;
    U  * I600;
    U  I601;
    U  I602;
    U  * I603;
};
typedef struct pcbt {
    U  * I402;
    UP  I78;
    U  I403;
    U  I404;
    U  I405;
    U  I406;
    U  I407;
    U  I408;
} PCBT;
typedef struct {
    int * I945;
    int * I946;
    int I947;
    union {
        long long enumDesc;
        long long classId;
    } I948;
} TypeData;
struct etype {
    U  I4 :8;
    U  I5;
    U  I6;
    U  I7 :1;
    U  I8 :1;
    U  I9 :1;
    U  I10 :1;
    U  I11 :1;
    U  I12 :1;
    U  I13 :1;
    U  I14 :1;
    U  I15 :1;
    U  I16 :4;
    U  I17 :1;
    U  I18 :1;
    U  I19 :1;
    U  I20 :1;
    U  I21 :1;
    U  I22 :1;
    U  I23 :1;
    U  I24 :1;
    U  I25 :2;
    U  I26 :1;
    U  I27 :2;
    U  I28 :1;
    U  I29 :1;
    U  I30 :1;
    U  I31 :1;
    U  I32 :1;
    U  I33 :1;
    TypeData  * I34;
    U  I35;
    U  I36;
    U  I37 :1;
    U  I38 :1;
    U  I39 :1;
    U  I40 :1;
    U  I41 :2;
    U  I42 :2;
    U  I43 :1;
    U  I44 :1;
    U  I45 :1;
    U  I46 :1;
    U  I47 :1;
    U  I48 :1;
    U  I49 :1;
    U  I50 :1;
    U  I51 :1;
    U  I52 :1;
    U  I53 :1;
    U  I54 :1;
    U  I55 :1;
    U  I56 :11;
};
struct iptmpl {
    QIRD  * I670;
    void * I671;
    void * I672;
    UP  I673;
    UP  I674;
    struct iptmpl * I675[2];
};
typedef unsigned long long FileOffset;
typedef struct _RmaMultiInputTable {
    U  I957 :1;
    U  I958 :1;
    U  I611 :2;
    U  I612 :4;
    U  I613 :5;
    U  I959 :1;
    U  I960 :1;
    U  I961 :1;
    U  I962 :1;
    U  I963 :1;
    U  I964 :1;
    U  I965;
    U  I966;
    U  I256;
    U  I967;
    U  I968 :1;
    U  I969 :31;
    union {
        U  utable;
        U  edgeInputNum;
    } I639;
    U  I970 :4;
    U  I971 :4;
    U  I972 :4;
    U  I973 :4;
    U  I974 :4;
    U  I975 :4;
    U  I976 :1;
    U  I977 :1;
    U  I978 :1;
    U  I979 :1;
    U  I980 :5;
    HsimExprChar  * I981;
    UB  * I982;
    UB  * I983;
    struct _RmaMultiInputTable * I956;
    struct _RmaMultiInputTable * I985;
} RmaMultiInputTable;
typedef struct _HsCgPeriod {
    U  I1037;
    U  I1038;
} HsCgPeriod;
typedef struct {
    U   I1039[2];
    U  I1040 :1;
    U  I1041 :1;
    U  I1042 :8;
    U  I1043 :8;
    U  I1044 :8;
    U  I1045 :4;
    U  I1046 :1;
    U  I1047 :1;
    unsigned long long I1048;
    unsigned long long I1049;
    unsigned long long I1050;
    unsigned long long I1051;
    unsigned long long I1038;
    U  I1037;
    U  I1052;
    U  I1053;
    U  I1054;
    U  I1055;
    U  I1056;
    HsCgPeriod  * I1057[10];
} HsimSignalMonitor;
typedef struct {
    InstNum  I1058;
    FlatNodeNum  I1059;
    U  I991;
    scalar  I1060;
    UB  I1061;
    UB  I1062;
    UB  I1063;
    UB  I1064;
    UB  I1065;
    UB  I1066;
    ULL  I1067;
    U  I1068;
    U  I1069;
    U  I1070;
    U  I1071;
    U  I1072;
    U  I1073;
    U  I1074;
    U  I1075;
    HsimSignalMonitor  * I1076;
    RP  I1077;
    RmaTimeStamp64  I1078;
    U  I1079;
    RmaTimeStamp64  I1080;
    U  I1081;
    UB  I1082 :1;
    UB  I1083 :1;
    UB  I1084 :1;
    RP  I1085;
} HsimNodeRecord;
typedef struct {
    RP  I1093;
    RP  pcode;
} RmaIbfPcode;
typedef struct {
    RP  I1093;
    RP  I664;
} RmaIbfIp;
typedef struct {
    U  I758;
    InstNum32  I630;
} RmaIbfIpById;
typedef struct {
    U  I667;
    U  val;
} RmaDynamicEblklq;
typedef struct {
    U  I667;
    U  I668;
} RmaFgpDynamicEblklq;
typedef struct {
    U  val;
} RmaDynamicEblk;
typedef struct {
    U  I650 :28;
    U  I1094 :1;
    U  I1095 :1;
    U  I1096 :1;
    U  I1097 :1;
    U  I1098;
    RP  I1099;
    RP  I1100;
    U   I1101[1];
} RmaDbsedRtlLoads;
typedef struct {
    RP  I1102;
    RP  pfn;
    RP  pcode;
} RmaSeqPrimOutputEblkData;
typedef RP  RCICODE;
typedef struct {
    RmaEblk  I662;
} RmaEvTriggeredOrSyncLoadCg;
typedef struct {
    RO  I953;
    RP  pcode;
} SchedGateFanout;
typedef struct {
    RO  I953;
    RP  pcode;
    U   I1014[4];
} SchedSelectGateFanout;
typedef struct {
    RP  pcode;
    RmaEblklq  I662;
} SchedGateEblk;
typedef struct {
    RP  pcode;
    RmaEblklq  I662;
    UB  * I1103;
} SchedSelectGateEblk;
typedef struct {
    RmaEblk  I662;
    RP  I1104;
} RmaAnySchedSampleSCg;
typedef struct {
    RmaEblk  I662;
    RP  I1103;
    RP  I1104;
    vec32  I1105;
} RmaAnySchedVCg;
typedef struct {
    RmaEblk  I662;
    RP  I1103;
    RP  I1104;
    vec32   I720[1];
} RmaAnySchedWCg;
typedef struct {
    RmaEblk  I662;
    RP  I1103;
    RP  I1104;
    scalar   I1106[1];
} RmaAnySchedECg;
typedef struct {
    U  I1107;
    U  I650;
    U  I991;
    U  I1108;
    RmaIbfIp  * I1109;
    EBLK  I662;
    void * val;
} RmaThreadSchedCompiledLoads;
typedef struct {
    U  I650;
    U  I658;
    RmaThreadSchedCompiledLoads  * I1110;
} RmaSchedCompileLoadsCg;
typedef struct {
    RP  I1111;
} RmaRootCbkCg;
typedef struct {
    RP  I1112;
} RmaRootForceCbkCg;
typedef struct {
    RmaEblk  I662;
    RP  I1113;
} RmaForceCbkJmpCg;
typedef struct {
    U  I59;
    U  I658 :31;
    U  I1114 :1;
    vec32  I752;
    U  I1115;
    RP  I1116;
    RP  I1117;
} RmaForceSelectorV;
typedef struct {
    U  I59;
    RmaIbfPcode  I1124;
} RmaNetTypeDriverGate;
typedef struct {
    U  I59;
    U  I607;
    RmaIbfPcode   I1124[1];
} RmaNetTypeScatterGate;
typedef struct {
    U  I59;
    RmaIbfPcode  I1124;
} RmaNetTypeGatherGate;
typedef struct {
    RmaIbfPcode  I1125;
    U  I1126 :3;
    U  I1127 :1;
    U  I1128 :1;
    U  I966 :16;
} RmaNbaGateOfn;
typedef struct {
    U  I59;
    NBS  I1129;
    RmaIbfPcode  I1125;
} RmaNbaGate1;
typedef struct {
    RP  ptable;
    RP  pfn;
    RP  pcode;
} Rma1InputGateFaninCgS;
typedef struct RmaSeqPrimOutputS_ RmaSeqPrimOutputOnClkS;
struct RmaSeqPrimOutputS_ {
    RP  pfn;
    U  state;
    U  I1132;
    RP  I1133;
    scalar  val;
    union {
        U  I646;
        U  I628;
    } I639;
    RP   I1134[1];
};
typedef struct {
    U  I59;
    U  iinput;
    UB  I1136;
    RP  I1137;
} RmaCondOptLoad;
typedef struct {
    U  I59;
    U  iinput;
    UB  I1136;
    RP  I1137;
} RmaMacroStateUpdate;
typedef struct {
    U  I59;
    U  state;
    U  I1138;
    UB  I1136;
    U  * I1139;
} RmaMacroState;
typedef struct {
    U  iinput;
    RP  I1140;
} RmaMultiInputLogicGateCg;
typedef struct {
    U  iinput;
    RP  ptable;
    RP  I1140;
} RmaSeqPrimEdgeInputCg;
typedef struct {
    RP  I1140;
} RmaSimonCellEdgeInputCg;
typedef struct {
    RmaEblk  I662;
    RP  pcode;
} RmaSched0GateCg;
typedef struct {
    RmaEblk  I662;
    RP  pcode;
    RP  pfn;
    scalar  I645;
    scalar  I1141;
} RmaUdpDeltaGateCg;
typedef struct {
    RmaEblk  I662;
    RP  pcode;
    RP  pfn;
    scalar  I1142;
} RmaSchedDeltaGateCg;
typedef struct {
    RP  pcode;
    RP  pfn;
    RmaDynamicEblk  I662;
    scalar  I1142;
    scalar  I1143;
    scalar  I1144;
    scalar  I560;
} RmaDynamicSchedDeltaGateCg;
typedef struct {
    UB  I1145;
    RP  I1146;
    RP  I1147;
} RmaPropNodeSeqLhsSCg;
typedef struct {
    RmaEblk  I662;
    RP  pcode;
    U  I991;
    U   I651[1];
} RmaBitEdgeEblk;
typedef struct {
    U  I59;
    U  I1148;
    RP  I751;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaGateDelay;
typedef struct {
    U  I59;
    RP  I751;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaGateBehavioralDelay;
typedef struct {
    U  I59;
    union {
        RP  I1404;
        RP  I1700;
        RP  I1717;
    } I725;
    RmaIbfPcode  I1125;
} RmaMPDelay;
typedef struct {
    U  I59;
    RmaPulse  I1149;
    RmaIbfPcode  I1125;
} RmaMPPulseHybridDelay;
typedef struct {
    U  I59;
    RmaIbfPcode  I1125;
    RmaMps  I1150;
} RmaMPHybridDelay;
typedef struct {
    U  I59;
    U  I1151;
    RmaIbfPcode  I1125;
    RmaEblk  I710;
} RmaMPHybridDelayPacked;
typedef struct {
    U  I59;
    RmaIbfPcode  I1125;
    RmaMpspNewCsdf  I1152;
} RmaMPPulseDelay;
typedef struct {
    U  I59;
    RmaMpsp  I1152;
    RmaIbfPcode  I1125;
} RmaMPPulseOptHybridDelay;
typedef struct _RmaBehavioralTransportDelay {
    U  I59;
    RP  I624;
    RmaTransEventHdr  I997;
    RP  I748;
    RmaIbfPcode  I1125;
} RmaBehavioralTransportDelayS;
typedef struct {
    U  I59;
    RP  I624;
    RmaTransEventHdr  I997;
    RP  I748;
    RmaIbfPcode  I1125;
} RmaNtcTransDelay;
typedef struct {
    U  I59;
    RP  I624;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaNtcTransMpwOptDelay;
typedef struct {
    U  I59;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaNtcTransZeroDelay;
typedef struct {
    U  I59;
    RP  I1153;
    RP  I1154;
    RmaTransEventHdr  I997;
    RP  I748;
    RmaIbfPcode  I1125;
} RmaNtcTransDelayRF;
typedef struct {
    U  I59;
    RP  I1153;
    RP  I1154;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaNtcTransMpwOptDelayRF;
typedef struct {
    U  I59;
    RP  I1155;
    RmaTransEventHdr  I997;
    RP  I748;
    RmaIbfPcode  I1125;
} RmaICTransDelay;
typedef struct {
    U  I59;
    RP  I1155;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaICTransMpwOptDelay;
typedef struct {
    U  I59;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaICTransZeroDelay;
typedef struct {
    U  I59;
    RP  I751;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaICSimpleDelay;
typedef struct {
    U  I59;
    union {
        RP  psimple;
        RP  I1700;
        RP  I1717;
    } I725;
    RmaIbfPcode  I1125;
} RmaICDelay;
typedef struct {
    U  I59;
    RP  I751;
    RmaEblk  I662;
    RmaIbfPcode  I1125;
} RmaPortDelay;
typedef struct {
    U  I966;
    RP  I1156;
} RmaRtlXEdgesLoad;
typedef struct {
    U  I59;
    RmaRtlXEdgesLoad   I1156[(5)];
    void * I1157;
} RmaRtlXEdgesHdr;
typedef struct {
    U  I59;
    US  I1158;
    US  I1159 :1;
    US  I980 :15;
    RP  I1160;
    RP  I1161;
    RP  I1162;
} RmaRtlEdgeBlockHdr;
typedef struct {
    RP  I1163;
    RP  I1164;
} RemoteDbsedLoad;
typedef struct {
    RmaEblk  I662;
    RP  I1165;
    RP  I1166;
    US  I1167;
    UB  I1168;
    UB  I1169 :2;
    UB  I1170 :2;
    UB  I1171 :1;
    UB  I980 :3;
    U  I627;
    RP  I1172;
    RP   I755[(5)];
    RP   I757[(5)];
    US  I1173;
    US  I1174;
    RP  I1175;
    RemoteDbsedLoad   I1176[1];
} RmaRtlEdgeBlock;
typedef struct TableAssign_ {
    struct TableAssign_ * I956;
    struct TableAssign_ * I742;
    U  I59;
    U  I1178 :1;
    U  I1179 :1;
    U  I1180 :2;
    U  I1181 :1;
    U  I646 :8;
    U  I1182 :1;
    U  I1183 :1;
    U  I1184 :1;
    U  I1185 :1;
    U  I1186 :1;
    U  I1187 :1;
    U  I1188 :1;
    U  I1189 :1;
    U  I1190 :1;
    U  I1191 :1;
    U  I980 :9;
    RP  ptable;
    RP  I1140;
} TableAssign;
typedef struct TableAssignLayoutOnClk_ {
    struct TableAssignLayoutOnClk_ * I956;
    struct TableAssignLayoutOnClk_ * I742;
    U  I59;
    U  I1178 :1;
    U  I1179 :1;
    U  I1180 :2;
    U  I1181 :1;
    U  I646 :8;
    U  I1182 :1;
    U  I1183 :1;
    U  I1184 :1;
    U  I1185 :1;
    U  I1186 :1;
    U  I1187 :1;
    U  I1188 :1;
    U  I1189 :1;
    U  I1190 :1;
    U  I1191 :1;
    U  I980 :9;
    RP  ptable;
    RmaSeqPrimOutputOnClkS  I1193;
    RmaEblk  I662;
} TableAssignLayoutOnClk;
typedef struct {
    U  state;
    U  I1194;
} RmaSeqPrimOutputOnClkOpt;
typedef struct TableAssignLayoutOnClkOpt_ {
    struct TableAssignLayoutOnClkOpt_ * I956;
    struct TableAssignLayoutOnClkOpt_ * I742;
    U  I1196;
    U  I1178 :1;
    U  I1179 :1;
    U  I1180 :2;
    U  I1181 :1;
    U  I646 :8;
    U  I1182 :1;
    U  I1183 :1;
    U  I1184 :1;
    U  I1185 :1;
    U  I1186 :1;
    U  I1187 :1;
    U  I1188 :1;
    U  I1189 :1;
    U  I1190 :1;
    U  I1191 :1;
    U  I980 :9;
    RmaSeqPrimOutputOnClkOpt  I1193;
    RmaSeqPrimOutputEblkData  I1197;
} TableAssignLayoutOnClkOpt;
typedef struct {
    U  I59;
    RP  I742;
    RP  I1198;
} RmaTableAssignList;
typedef struct {
    U  I59;
    RP  I742;
    RP  I1198;
    RP  I1199;
    RP  I1133;
    RP  I1200;
    US  I646;
    UB  I1060;
    UB  I1201;
    UB  I1202;
    UB  I716;
    RP   I1203[0];
} RmaThreadTableAssignList;
typedef struct {
    RP  I1199;
    RP  I1133;
    RP  I1200;
    US  I646;
    UB  I1060;
    UB  I1201;
    UB  I1202;
    UB  I716;
} RmaThreadTableHeader;
typedef struct {
    RP  I1163;
} RmaWakeupListCg;
typedef struct {
    RP  I1163;
} RmaWakeupArrayCg;
typedef struct {
    RP  I1163;
    RP  I1204;
} RmaPreCheckWakeupListCg;
typedef struct {
    RP  I1163;
    RP  I1204;
} RmaPreCheckWakeupArrayCg;
typedef struct {
    U  I1205;
    U  I646;
    RmaTimeStamp   I1206[1];
} RmaTsArray;
typedef struct {
    U  iinput;
    RP  I1207;
} RmaConditionsMdb;
typedef struct {
    RP  I1208;
    RP  I1209;
    U  I1210;
} RmaTcListHeader;
typedef struct {
    RP  I956;
    RP  I1211;
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
} RmaTcCoreSimple;
typedef struct {
    RP  I956;
    RP  I1211;
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
} RmaTcCoreConditional;
typedef struct {
    RP  I956;
    RP  I1211;
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
    RP  I1224;
} RmaTcCoreConditionalOpt;
typedef struct {
    RP  I956;
    RP  I1211;
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1224;
    RP  I1225;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaTcCoreConditionalMtc;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
} RmaTcCoreSimpleNoList;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
} RmaTcCoreConditionalNoList;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
    RP  I1224;
} RmaTcCoreConditionalOptNoList;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1224;
    RP  I1225;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaTcCoreConditionalMtcNoList;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1224;
    RP  I1225;
    RP  I1134;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaTcCoreConditionalMtcNoListMdb;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
    RP  I1134;
} RmaTcCoreConditionalNoListMdb;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    U  I1228;
    RP  I1229;
    RP  I1230;
    RP  I1223;
    RP  I1231;
    RP  I1232;
    RmaTimeStamp  I1233;
} RmaTcCoreNochange;
typedef struct {
    RP  I1234;
    RP  I956;
} RmaTcCoreNochangeList;
typedef struct {
    RP  I1212;
    RP  I657;
    U  I1213;
    scalar  I966;
    scalar  I1214;
    US  I1215 :1;
    US  I1216 :1;
    US  I1217 :1;
    US  I1218 :1;
    US  I1219 :1;
    US  I1220 :1;
    US  I1221 :1;
    US  I1222 :5;
    RP  I1223;
    RmaEblk  I662;
    U  I1235;
} RmaTcCoreFullskew;
typedef struct {
    RP  I1236;
    RP  I956;
} RmaTcCoreFullskewList;
typedef struct {
    RP  I1207;
    RmaTimeStamp  I1237;
    scalar  I1238;
} RmaConditionalTSLoadNoList;
typedef struct {
    RP  I956;
    RP  I1207;
    RmaTimeStamp  I1237;
    scalar  I1238;
} RmaConditionalTSLoad;
typedef struct {
    RmaTimeStamp  I1237;
    scalar  I1238;
    US  I966;
    RP  I1224;
} RmaConditionalTSLoadOptNoList;
typedef struct {
    RP  I956;
    RmaTimeStamp  I1237;
    scalar  I1238;
    US  I966;
    RP  I1224;
} RmaConditionalTSLoadOpt;
typedef struct {
    RP  I1224;
    RP  I1239;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaConditionalTSLoadMtcNoList;
typedef struct {
    RP  I1134;
    RP  I1224;
    RP  I1239;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaConditionalTSLoadMtcNoListMdb;
typedef struct {
    RP  I956;
    RP  I1224;
    RP  I1239;
    U  I1226;
    RmaConditionsMdb   arr[1];
} RmaConditionalTSLoadMtc;
typedef struct {
    U  I1240;
    U  I1241;
    FlatNodeNum  I1092;
    U  I991;
    U  I1242;
    U  I1243;
    RmaIbfPcode  I1125;
    union {
        scalar  I1244;
        vec32  I1245;
        scalar  * I1246;
        vec32  * I1247;
    } val;
} RmaScanSwitchData;
typedef struct {
    U  I1240;
    U  I1241;
    U  I991;
    FlatNodeNum  I1092;
    RmaIbfPcode  I1125;
    union {
        scalar  I1244;
        vec32  I1245;
        scalar  * I1246;
        vec32  * I1247;
        double I1248;
    } val;
} RmaRtvsGateData;
typedef struct {
    RP  I956;
    RP  I742;
    RP  I1249;
} RmaDoublyLinkedListElem;
typedef struct {
    RP  I1250;
    RP  I1251;
    U  I1252 :1;
    U  I1253 :1;
    U  I1254 :1;
    U  I1255 :4;
    U  I1256 :1;
    U  I1084 :1;
    U  I1257 :1;
    U  I1258;
} RmaSwitchGateInCbkListInfo;
typedef struct {
    union {
        RmaDoublyLinkedListElem  I1767;
        RmaSwitchGateInCbkListInfo  I2;
    } I639;
    RmaIbfPcode  I1125;
} RmaSwitchGate;
typedef struct RmaNonEdgeLoadData1_ {
    US  I1259;
    scalar  val;
    scalar  I1260 :1;
    scalar  I1261 :1;
    scalar  I1262 :3;
    scalar  I1263 :1;
    scalar  I1264 :1;
    scalar  I1265 :1;
    U  I1266;
    U  I1267;
    RP  I755;
    RP  I1268;
    RP  I1092;
    RP  I1269;
    RP  I1270;
} RmaNonEdgeLoadData1;
typedef struct RmaNonEdgeLoadHdr1_ {
    UB  I1260;
    UB  I1271;
    UB  I1060;
    RmaNonEdgeLoadData1  * I1156;
    RmaNonEdgeLoadData1  * I742;
    RP  I1175;
    void * I1157;
} RmaNonEdgeLoadHdr1;
typedef struct RmaNonEdgeLoadHdrPrl1_ {
    U  I1272;
    RP  I657;
} RmaNonEdgeLoadHdrPrl1;
typedef struct RmaNonEdgeLoadArrayHdr1_ {
    UB  I1260 :1;
    UB  I1271 :1;
    UB  I1060;
    int I627;
    RmaNonEdgeLoadData1  * I631;
    U  * I1273;
    RP  I1175;
    void * I1157;
} RmaNonEdgeLoadArrayHdr1;
typedef struct RmaNonEdgeLoadDataArray1_ {
    U  I1274;
} RmaNonEdgeLoadDataArray1;
typedef struct RmaChildClockProp_ {
    RP  I755;
    RP  I1275;
    RP  I1092;
    RP  pcode;
    scalar  val;
} RmaChildClockProp;
typedef struct RmaChildClockPropList1_ {
    RmaChildClockProp  * I1156;
    RmaChildClockProp  * I742;
} RmaChildClockPropList1;
typedef struct {
    UB  I1276;
    UB  I1277 :1;
    UB  I1278 :1;
    UB  I1279 :1;
    UB  I1280 :1;
    UB  I980 :4;
    US  cedges;
    RP  I1281;
} RmaMasterXpropLoadHdr;
typedef struct {
    UB  I1276;
    UB  I1282;
    UB  I1283;
    UB  I1284 :1;
    UB  I1285 :1;
    UB  I980 :6;
    U  cedges;
} RmaXpropLoadHdr;
typedef struct {
    UB  I1282;
    UB  I1283;
    UB  I1286;
    UB  I1287;
    U  cedges :29;
    U  I1278 :1;
    U  I1288 :1;
    U  I1289 :1;
    U  I1290;
    U  I1291;
    RP  I1292;
    RP  I1293;
    RmaRtlEdgeBlockHdr  * I1294;
} RmaChildXpropLoadHdr;
struct clock_load {
    U  I234 :5;
    U  I235 :12;
    U  I236 :1;
    U  I237 :2;
    U  I238 :1;
    U  I239 :1;
    U  I240 :1;
    U  I241 :9;
    U  I242;
    U  I243;
    void (* pfn)(void * I245, char val);
};
typedef struct clock_data {
    U  I250 :1;
    U  I251 :1;
    U  I252 :1;
    U  I253 :1;
    U  I234 :5;
    U  I235 :12;
    U  I254 :6;
    U  I255 :1;
    U  I237 :2;
    U  I238 :1;
    U  I241 :1;
    U  I256;
    U  I257;
    U  I258;
    U  I242;
    U  I259;
    U  I260;
    U  I261;
    U  I262;
    U  I263;
} HdbsClockData;
struct clock_hiconn {
    U  I267;
    U  I268;
    U  I242;
    U  I237;
};
typedef union _RmaCbkMemOptUnion {
    RP  I1295;
    RP  I1296;
    RP  I1297;
} RmaCbkMemOptUnion;
typedef struct _RmaDaiOptCg {
    RmaCbkMemOptUnion  I1298;
} RmaDaiOptCg;
struct futq_slot2 {
    U  I702;
    U   I703[32];
};
struct futq_slot1 {
    U  I699;
    struct futq_slot2  I700[32];
};
struct futq_info {
    scalar  * I694;
    U  I695;
    U  I696;
    struct futq_slot1  I697[32];
};
struct futq {
    struct futq * I683;
    struct futq * I685;
    RmaEblk  * I686;
    RmaEblk  * I687;
    U  I667;
    U  I1;
    DEblkPoolT  * I688;
};
struct sched_table {
    struct futq * I689;
    struct futq I690;
    struct hash_bucket * I691;
    struct hash_bucket * I693;
};
struct dummyq_struct {
    clock_struct  I1299;
    EBLK  * I1300;
    EBLK  * I1301;
    EBLK  * I1302;
    struct futq * I1303;
    struct futq * I1304;
    struct futq * I1305;
    struct sched_table * I1306;
    struct futq_info * I1308;
    struct futq_info * I1310;
    U  I1311;
    U  I1312;
    U  I1313;
    U  I1314;
    U  I1315;
    U  I1316;
    U  I1317;
    struct millenium * I1318;
    EBLK  * I1320;
    EBLK  * I1321;
    EBLK  * I1322;
    EBLK  * I1323;
    EBLK  * I1324;
    EBLK  * I1325;
    EBLK  * I1326;
    EBLK  * I1327;
    EBLK  * I1328;
    EBLK  * I1329;
    EBLK  * I1330;
    EBLK  * I1331;
    EBLK  * I1332;
    EBLK  * I1333;
    EBLK  * I1334;
    EBLK  * I1335;
    EBLK  * I1336;
    MPS  * I1337;
    struct retain_t * I1338;
    EBLK  * I1339;
    EBLK  * I1340;
    EBLK  * I1341;
    EBLK  * I1342;
    EBLK  * I1343;
    EBLK  * I1344;
    EBLK  * I1345;
    EBLK  * I1346;
    EBLK  * I1347;
    EBLK  * I1348;
    EBLK  * I1349;
    EBLK  * I1350;
    EBLK  * I1351;
    EBLK  * I1352;
    EBLK  * I1353;
    EBLK  * I1354;
    EBLK  * I1355;
    EBLK  * I1356;
    EBLK  * I1357;
    EBLK  * I1358;
    EBLK  * I1359;
    EBLK  * I1360;
    EBLK  * I1361;
    EBLK  * I1362;
    EBLK  * I1363;
    EBLK  * I1364;
    EBLK  I1365;
    EBLK  * I1366;
    EBLK  * I1367;
    int I1368;
    struct vcs_globals_t * I1369;
    clock_struct  I1371;
    unsigned long long I1372;
    EBLK  * I1373;
    EBLK  * I1374;
    void * I1375;
    U  semilerOptQueuesFlag;
    U  I1377;
};
typedef void (* FP)(void *  , scalar   );
typedef void (* FP1)(void *  );
typedef void (* FPRAP)(void *  , vec32  *  , U   );
typedef U  (* FPU1)(void *  );
typedef void (* FPV)(void *  , UB  *  );
typedef void (* FPVU)(void *  , UB  *  , U   );
typedef void (* FPDP)(void *  , void *  , scalar   );
typedef void (* FPVDP)(void *  , void *  , void *  );
typedef void (* FPLSEL)(void *  , scalar   , U   );
typedef void (* FPLSELV)(void *  , vec32  *  , U   , U   );
typedef void (* FPFPV)(UB  *  , UB  *  , U   , U   , U   , U   , U   , UB  *  , U   );
typedef void (* FPFA)(UB  *  , UB  *  , U   , U   , U   , U   , U   , U   , UB  *  , U   );
typedef void (* FPRPV)(UB  *  , U   , U   , U   );
typedef void (* FPEVCDLSEL)(void *  , scalar   , U   , UB  *  );
typedef void (* FPEVCDLSELV)(void *  , vec32  *  , U   , U   , UB  *  );
typedef void (* FPNTYPE_L)(void *  , void *  , U   , U   , UB  *  , UB  *  , UB  *  , UB  *  , UB  *  , UB  *  , UB  *  , U   );
typedef void (* FPNTYPE_H)(void *  , void *  , U   , U   , UB  *  , UB  *  , UB  *  , UB  *  , U   );
typedef void (* FPNTYPE_LPAP)(void *  , void *  , void *  , U   , U   , UB  *  , UB  *  , U   );
typedef void (* FPNTYPE_HPAP)(void *  , void *  , void *  , U   , U   , UB  *  , UB  *  , UB  *  , UB  *  , U   );
typedef struct _lqueue {
    int I1378;
    struct _lqueue * I713;
    EBLK  * I1380;
    EBLK  * I666;
    DEblkPoolT  * I688;
} Queue;
typedef struct {
    void * I1381;
    void * I1382;
    void * I1383[2];
    void * I1384;
} ClkLevel;
typedef struct {
    unsigned long long I1385;
    EBLK  I1288;
    U  I1386;
    U  I1387;
    union {
        void * pHeap;
        Queue  * pList;
    } I639;
    unsigned long long I1388;
    ClkLevel  I1389;
    Queue   I1390[1];
} Qhdr;
extern scalar  * pUpdateForDynVcd;
extern UB   Xvalchg[];
extern UB   X4val[];
extern UB   X3val[];
extern UB   X2val[];
extern UB   XcvtstrTR[];
extern UB   Xcvtstr[];
extern UB   Xbuf[];
extern UB   Xbitnot[];
extern UB   Xwor[];
extern UB   Xwand[];
extern U   Xbitnot4val[];
extern UB   globalTable1Input[];
extern __thread unsigned long long vcs_clocks;
extern __thread unsigned long long ref_vcs_clocks;
extern UB   Xunion[];
extern UB   vcsXunionCg[];
extern UB   vcsXworCg[];
extern UB   vcsXwandCg[];
extern U  fRTFrcRelCbk;
extern FP  txpFnPtr;
extern UP   bepatsFunctionArray[];
extern FP   rmaFunctionArray[];
extern UP   rmaFunctionRtlArray[];
extern UP   rmaFunctionHsRtlArray[];
extern FP   rmaFunctionLRArray[];
extern U  rmaFunctionCount;
extern U  rmaFunctionLRCount;
extern U  rmaFunctionLRDummyCount;
extern UP  rmaFunctionDummyEndPtr;
extern FP   rmaFunctionFanoutArray[];
extern __thread UB  dummyScalar;
extern __thread UB  fScalarIsForced;
extern __thread UB  fScalarIsReleased;
extern __thread UB  fScalarIsDeposited;
extern U  fNotimingchecks;
extern U  fFsdbDumpOn;
extern RP  * iparr;
extern FP1  * rmaPostAnySchedFnPtr;
extern FP1  * rmaPostAnySchedFnSamplePtr;
extern FP1  * rmaPostAnySchedVFnPtr;
extern FP1  * rmaPostAnySchedWFnPtr;
extern FP1  * rmaPostAnySchedEFnPtr;
extern FP1  * rmaPostSchedUpdateClockStatusFnPtr;
extern FP1  * rmaPostSchedUpdateClockStatusNonCongruentFnPtr;
extern FP1  * rmaPostSchedUpdateEvTrigFnPtr;
extern FP1  * rmaSched0UpdateEvTrigFnPtr;
extern FP1  * rmaPostSchedRecoveryResetDbsFnPtr;
extern U  fGblDataOrTime0Prop;
extern UB   rmaEdgeStatusValArr[];
extern UB   rmaposEdgeStatusArray[];
extern UB   rmanegEdgeStatusArray[];
extern FP1  * propForceCbkSPostSchedCgFnPtr;
extern FP1  * propForceCbkMemoptSPostSchedCgFnPtr;
extern FP1  * propForceCbkMemoptSPostSchedNativeVcCgFnPtr;
extern U  VCS_NCBK_Enabled;
extern UB  * ptableGbl;
extern U  * vcs_ptableOffsetsGbl;
extern UB  * expandedClkValues;
extern __thread Qhdr  * lvlQueue;
extern __thread unsigned threadIndex;
extern __thread unsigned fBufferingEvent;
extern int cPeblkThreads;
extern US   xedges[];
extern U  mhdl_delta_count;
extern U  ignoreSchedForScanOpt;
extern U  fignoreSchedForDeadComboCloud;
extern int fZeroUser;
extern U  fEveBusPullVal;
extern U  fEveBusPullFlag;
extern U  fFutEventPRL;
extern U  fParallelEBLK;
extern __thread UB  fNettypeIsForced;
extern __thread UB  fNettypeIsReleased;
extern EBLK  * peblkFutQ1Head;
extern EBLK  * peblkFutQ1Tail;
extern US  * edgeActionT;
extern unsigned long long * derivedClk;
extern U  fHashTableSize;
extern U  fSkipStrChangeOnDelay;
extern U  fHsimRuntimeSdfOpt;
extern U  fSkipMpTsUpdateOnStr;
extern scalar   edgeChangeLookUp[4][4];
extern U  fDoingTime0Prop;
extern U  fLoopDetectMode;
extern int gFLoopDectCodeEna;
extern U  fLoopReportRT;
extern U  rmaProfEvtProp;
extern U  semilerOptQueuesFlag;
extern int semilerOpt;


extern void *mempcpy(void* s1, void* s2, unsigned n);
extern RP* getDynamicVcdLocation(U patIdx, RP* pupdate);
extern UB* rmaEvalDelays(UB* pcode, scalar val);
extern UB* rmaEvalDelaysV(UB* pcode, vec32* pval);
extern void rmaPopTransEvent(UB* pcode);
extern void rmaSetupFuncArray(UP* ra, U c, U w);
extern void rmaSetupRTLoopReportPtrs(UP* funcs, UP* rtlFuncs, U cnt, U cntDummy, UP end);
extern void SinitHsimPats(void);
extern void VVrpDaicb(void* ip, U nIndex);
extern int SDaicb(void *ip, U nIndex);
extern void SDaicbForHsimNoFlagScalar(void* pDaiCb, unsigned char value, unsigned char isStrength);
extern void SDaicbForHsimWithFlagScalar(void* pDaiCb, unsigned char value, unsigned char isStrength);
extern void SDaicbForHsimNoFlagDynElabScalar(U* mem, unsigned char value, unsigned char isStrength);
extern void SDaicbForHsimWithFlagDynElabScalar(U* mem, unsigned char value, unsigned char isStrength);
extern void SDaicbForHsimNoFlagDynElabFrcRel(U* mem, unsigned char reason, int msb, int lsb, int ndx);
extern void SDaicbForHsimNoFlagFrcRel(void* pDaiCb, unsigned char reason, int msb, int lsb, int ndx);
extern void hsimDispatchCbkMemOptForVcd(RP p, U val);
extern void* hsimGetCbkMemOptCallback(RP p);
extern void hsimDispatchCbkMemOptNoDynElabS(RP* p, U val, U isStrength);
extern void hsimDispatchDACbkMemOptNoDynElabS(RP* p, U val, UB* da_byte, U isStrength);
extern U slaveTogglesThisTime;
extern void* hsimGetCbkPtrNoDynElab(RP p);
extern void hsimDispatchCbkMemOptDynElabS(U** pvcdarr, U** pcbkarr, U val, U isScalForced, U isScalReleased, U isStrength);
extern void hsimDispatchCbkMemOptNoDynElabVector(RP* /*RmaDaiOptCg* */p, void* pval, U /*RmaValueType*/ vt, U cbits);
extern void copyAndPropRootCbkCgS(RmaRootCbkCg* pRootCbk, scalar val);
extern void copyAndPropRootCbkCgV(RmaRootCbkCg* rootCbk, vec32* pval);
extern void copyAndPropRootCbkCgW(RmaRootCbkCg* rootCbk, vec32* pval);
extern void copyAndPropRootCbkCgE(RmaRootCbkCg* rootCbk, scalar* pval);
extern void Wsvvar_callback_non_dynamic1(RP* ptr, int);
extern void rmaExecEvSyncList(RP plist);
extern void Wsvvar_callback_virt_intf(RP* ptr);
extern void Wsvvar_callback_hsim_var(RP* ptr);
extern void checkAndConvertVec32To2State(vec32* value, vec32* svalue, U cbits, U* pforcedBits);
extern unsigned int fGblDataOrTime0Prop;
extern void SchedSemiLerMP1(UB* pmps, U partId);
extern void SchedSemiLerMPO(UB* pmpso, U partId);
extern void rmaDummyPropagate(void);
extern RP rmaTestCg(RP pcode, U vt, UB* value);
extern void hsUpdateModpathTimeStamp(UB* pmps);
extern void doMpd32One(UB* pmps);
extern void doMpdCommon(MPS* pmps);
extern TimeStamp GET_DIFF_DELAY_FUNC(TimeStamp ts);
extern void SchedSemiLerMP(UB* ppulse, U partId);
extern EBLK *peblkFutQ1Head;
extern EBLK *peblkFutQ1Tail;
extern void scheduleuna(UB *e, U t);
extern void scheduleuna_mp(EBLK *e, unsigned t);
extern void schedule(UB *e, U t);
extern void sched_hsopt(struct dummyq_struct * pQ, EBLK *e, U t);
extern void sched_millenium(struct dummyq_struct * pQ, void *e, U thigh, U t);
extern void schedule_1(EBLK *e);
extern void sched0(UB *e);
extern void sched0lq(EBLK *e);
extern void sched0lqnc(EBLK *e);
extern void sched0una(UB *e);
extern void sched0una_th(struct dummyq_struct *pq, UB *e);
extern void hsopt_sched0u_th(struct dummyq_struct *pq, UB *e);
extern void scheduleuna_mp_th(struct dummyq_struct *pq, EBLK *e, unsigned t);
extern void schedal(UB *e);
extern void sched0_th(struct dummyq_struct * pQ, EBLK *e);
extern void sched0u(UB *e);
extern void sched0u_th(struct dummyq_struct *pq, UB *e);
extern void sched0_hsim_front_th(struct dummyq_struct * pQ, UB *e);
extern void sched0_hsim_frontlq_th(struct dummyq_struct * pQ, UB *e);
extern void sched0lq_th(struct dummyq_struct * pQ, UB *e);
extern void schedal_th(struct dummyq_struct * pQ, UB *e);
extern void scheduleuna_th(struct dummyq_struct * pQ, void *e, U t);
extern void sched64cuna_th(struct dummyq_struct * pQ, void *e, U h, U l);
extern void schedule_th(struct dummyq_struct * pQ, UB *e, U t);
extern void schedule_1_th(struct dummyq_struct * pQ, EBLK *peblk);
extern void SetupLER_th(struct dummyq_struct * pQ, EBLK *e);
extern void FsdbReportClkGlitch(UB*,U);
extern void AddToClkGLitchArray(EBLK*);
extern void SchedSemiLer_th(struct dummyq_struct * pQ, EBLK *e);
extern void SchedSemiLerTXP_th(struct dummyq_struct * pQ, EBLK *e);
extern void SchedSemiLerTXPFreeVar_th(struct dummyq_struct * pQ, EBLK *e);
extern U getVcdFlags(UB *ip);
extern void VVrpNonEventNonRegdScalarForHsimOpt(void* ip, U nIndex);
extern void VVrpNonEventNonRegdScalarForHsimOpt2(void* ip, U nIndex);
extern void SchedSemiLerTBReactiveRegion(struct eblk* peblk);
extern void SchedSemiLerTBReactiveRegion_th(struct eblk* peblk, U partId);
extern void SchedSemiLerTr(UB* peblk, U partId);
extern void SchedSemiLerNBA(UB* peblk, U partId);
extern void NBA_Semiler(void *ip, void *pNBS);
extern void sched0sd_hsim(UB* peblk);
extern void vcs_sched0sd_hsim_udpclk(UB* peblk);
extern void vcs_sched0sd_hsim_udpclkopt(UB* peblk);
extern void sched0sd_hsim_PRL(UB* peblk);
extern void sched0lq_parallel_clk(EBLK* peblk);
extern void sched0lq_de(U* pe, void* ip, void* prout);
extern void sched0lq_hsopt_nonfgp_de(U* pe, void* ip, void* prout);
extern void sched0lq_hsopt_parallel_de(U* pe, void* ip, void* prout);
extern void sched0_de_inl(void* ip, void* prout);
extern void rmaPostDynamicSchedDeltaGate(UB* pcode);
extern U    isRtlClockScheduled(EBLK* peblk);
extern void doFgpRaceCheck(UB* pcode, UB* p, U flag);
extern void doSanityLvlCheck();
extern void sched0lq_parallel_ova(EBLK* peblk);
extern void sched0lq_parallel_ova_precheck(EBLK* peblk);
extern void rmaDlpEvalSeqPrim(UB* peblk, UB val, UB preval);
extern void appendNtcEvent(UB* phdr, scalar s, U schedDelta);
extern void appendTransEventS(RmaTransEventHdr* phdr, scalar s, U schedDelta);
extern void schedRetainHsim(MPS* pMPS, scalar sv, scalar pv);
extern void updateRetainHsim(MPS* pMPS,scalar sv, scalar pv);
extern void hsimCountXEdges(void* record,  scalar s);
extern void hsimRegisterEdge(void* sm,  scalar s);
extern EBLK* pvcsGetLastEventEblk(U thid);
extern void insertTransEventIC(RmaTransEventHdr* phdr, scalar s, scalar pv, scalar resval, U schedDelta, int re, UB* predd, U fpdd);
extern void insertNtcEventRF(RmaTransEventHdr* phdr, scalar s, scalar pv, scalar resval, U schedDelta, U* delays);
extern U doTimingViolation(RmaTimeStamp ts,RP* pdata, U fskew, U limit, U floaded, U fcondopt, RmaTimeStamp tsNochange);
extern void sched_gate_hsim(EBLK* peblk, unsigned t, RP* offset, U gd_info, U encodeInPcode, void* propValue);
extern int getCurSchedRegion();
extern FP getRoutPtr(RP, U);
extern U rmaChangeCheckAndUpdateE(scalar* pvalDst, scalar* pvalSrc, U cbits);
extern void rmaUpdateE(scalar* pvalDst, scalar* pvalSrc, U cbits);
extern U rmaChangeCheckAndUpdateEFromW(scalar* pvalDst, vec32* pvalSrc, U cbits);
extern void rmaLhsPartSelUpdateE(scalar* pvalDst, scalar* pvalSrc, U index, U width);
extern void rmaUpdateWithForceSelectorE(scalar* pvalDst, scalar* pvalSrc, U cbits, U* pforceSelector);
extern void rmaUpdateWFromE(vec32* pvalDst, scalar* pvalSrc, U cbits);
extern U rmaLhsPartSelWithChangeCheckE(scalar* pvalDst, scalar* pvalSrc, U index, U width);
extern void rmaLhsPartSelWFromE(vec32* pvalDst, scalar* pvalSrc, U index,U width);
extern U rmaChangeCheckAndUpdateW(vec32* pvalDst, vec32* pvalSrc, U cbits);
extern void rmaUpdateW(vec32* pvalDst, vec32* pvalSrc, U cbits);
extern void rmaUpdateEFromW(scalar* pvalDst, vec32* pvalSrc, U cbits);
extern void *VCSCalloc(size_t size, size_t count);
extern void *VCSMalloc(size_t size);
extern void VCSFree(void *ptr);
extern U rmaLhsPartSelWithChangeCheckW(vec32* pvalDst, vec32* pvalSrc, U index,U width);
extern void rmaLhsPartSelEFromW(scalar* pvalDst, vec32* pvalSrc, U index,U width);
extern U rmaLhsPartSelWithChangeCheckEFromW(scalar* pvalDst, vec32* pvalSrc, U index,U width);
extern void rmaLhsPartSelUpdateW(vec32* pvalDst, vec32* pvalSrc, U index, U width);
extern void rmaEvalWunionW(vec32* dst, vec32* src, U cbits, U count);
extern void rmaEvalWorW(vec32* dst, vec32* src, U cbits, U count);
extern void rmaEvalWandW(vec32* dst, vec32* src, U cbits, U count);
extern void rmaEvalUnionE(scalar* dst, scalar* src, U cbits, U count, RP ptable);
typedef U RmaCgFunctionType;
extern RmaIbfPcode* rmaEvalPartSelectsW(vec32* pvec32, U startIndex, U onWidth, U offWidth, U count, RmaIbfPcode* pibfPcode, U fnonRootForce, UB* pevcdStatus);
extern RmaIbfPcode* rmaEvalPartSelectsWLe32(vec32* pvec32, U startIndex, U onWidth, U offWidth, U count, RmaIbfPcode* pibfPcode, U fnonRootForce, UB* pevcdStatus);
extern RmaIbfPcode* rmaEvalPartSelectsWToE(vec32* pvec32, U startIndex, U onWidth, U offWidth, U count, RmaIbfPcode* pibfPcode, U fnonRootForce);
extern RmaIbfPcode* rmaEvalPartSelectsEToE(scalar* pv, U startIndex, U onWidth, U offWidth, U count, RmaIbfPcode* pibfPcode, U fnonRootForce, UB* pevcdStatus);
extern RmaIbfPcode* rmaEvalPartSelectsEToW(scalar* pv, U startIndex, U onWidth, U offWidth, U count, RmaIbfPcode* pibfPcode, U fnonRootForce);
extern U rmaEvalBitPosEdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitNegEdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitChangeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U VcsForceVecVCg(UB* pcode, UB* pval, UB* pvDst, UB* pvCur, U fullcbits, U ibeginSrc, U ibeginDst, U width, U/*RmaValueConvType*/ convtype, U/*RmaForceType*/ frcType, UB* prhs, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsReleaseVecVCg(UB* pcode, UB* pvDst, U fullcbits, U ibeginDst, U width, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsForceVecWCg(UB* pcode, UB* pval, UB* pvDst, UB* pvCur, U fullcbits, U ibeginSrc, U ibeginDst, U width, U/*RmaValueConvType*/ convtype, U /*RmaForceType*/ frcType, UB* prhs, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsReleaseVecWCg(UB* pcode, UB* pvDst, U fullcbits, U ibeginDst, U width, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsForceVecECg(UB* pcode, UB* pval, UB* pvDst, UB* pvCur, U fullcbits, U ibeginSrc, U ibeginDst, U width, U /*RmaValueConvType*/ convtype, U /*RmaForceType*/ frcType,UB* prhs, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsForceVecACg(UB* pcode, UB* pval, UB* pvDst, UB* pvCur, U fullcbits, U ibeginSrc, U ibeginDst, U width, U /*RmaValueConvType*/ convtype, U /*RmaForceType*/ frcType,UB* prhs, UB* prhsDst, U frhs, U* pforcedbits, U fisRoot);
extern U VcsReleaseVecCg(UB* pcode, UB* pvDst, U ibeginDst, U width, U /*RmaValueType*/ type,U fisRoot, UB* prhsDst, U frhs, U* pforcedbits);
extern U VcsDriveBitsAndDoChangeCheckV(vec32* pvSel, vec32* pvCur, U fullcbits, U* pforcedbits, U isRoot);
extern U VcsDriveBitsAndDoChangeCheckW(vec32* pvSel, vec32* pvCur, U fullcbits, U* pforcedbits, U isRoot);
extern U VcsDriveBitsAndDoChangeCheckE(scalar* pvSel, scalar* pvCur, U fullcbits, U* pforcedbits, U isRoot);
extern void cgvecDebug_Eblk(UB* pcode);
extern U rmaCmpW(vec32* pvalDst, vec32* pvalSrc, U index, U width);
extern void copyVec32ArrMask(vec32* pv1, vec32* pv2, U len, U* mask);
extern void* memcpy(void*, const void*, size_t);
extern int memcmp(const void*, const void*, size_t);
extern void propagateScanOptPathVal(EBLK *peblk);
extern UB* rmaProcessRtvsSwitches(UB* pcode, scalar val);
extern UB* rmaProcessScanSwitches(UB* pcode, scalar val);
extern UB* rmaProcessScanSwitchesV(UB* pcode, vec32 *pval);
extern UB* rmaProcessScanoptDump(UB* pcode, scalar val);
extern UB* rmaProcessScanoptDumpV(UB* pcode, vec32 *pval);
extern UB* rmaProcessScanChainOptSeqPrims(UB* pcode, scalar val);
extern void schedResetRecoveryDbs(U cedges, EBLK* peblkFirst);
extern UB* rmaEvalUnaryOpV(UB* pcode, vec32* pval);
extern UB* rmaEvalBinaryOpV(UB* pcode, vec32* pval);
extern UB* rmaEvalBinaryOpVOneFanoutCount(UB* pcode, vec32* pval);
extern UB* rmaEvalBinaryOpVLargeFanoutCount(UB* pcode, vec32* pval);
extern UB* rmaEvalAndOpVOneFanoutCount(UB* pcode, vec32* value);
extern UB* rmaEvalAndOpVLargeFanoutCount(UB* pcode, vec32* value);
extern UB* rmaEvalAndOpV(UB* pcode, vec32* value);
extern UB* rmaEvalOrOpVOneFanoutCount(UB* pcode, vec32* value);
extern UB* rmaEvalOrOpVLargeFanoutCount(UB* pcode, vec32* value);
extern UB* rmaEvalOrOpV(UB* pcode, vec32* value);
extern UB* rmaEvalTernaryOpV(UB* pcode, vec32* pval);
extern UB* rmaEvalUnaryOpW(UB* pcode, vec32* pval);
extern UB* rmaEvalBinaryOpW(UB* pcode, vec32* pval);
extern UB* rmaEvalTernaryOpW(UB* pcode, vec32* pval);
extern UB* rmaEvalUnaryOpE(UB* pcode, scalar* pv);
extern UB* rmaEvalBinaryOpE(UB* pcode, scalar* pv);
extern UB* rmaEvalTernaryOpE(UB* pcode, scalar* pv);
extern UB* rmaEvalTernaryOpS(UB* pcode, scalar val);
extern scalar rmaGetScalarFromWCg(vec32* pval, U index);
extern void rmaSetScalarInWCg(vec32* pval, U index, scalar s);
extern void rmaSetWInW(vec32* dst, vec32* src, U index, U indexSrc, U width);
extern void setHsimFunc(void* ip, U offset);
extern void vcs_updateHsimFunc(void* ip, U offset);
extern void unsetHsimFunc(void* ip);
extern U fProfEvtProp;
extern UB* getEvcdStatusByFlagsE(scalar* pscalar, UB* pevcdTBDriverFlags, U cdrivers, UB* table, U cbits);
extern UB* getEvcdStatusByFlagsV(vec32* pvec32, UB* pevcdTBDriverFlags, U cdrivers, UB* table, U cbits);
extern UB* getEvcdStatusByFlagsW(vec32* pvec32, UB* pevcdTBDriverFlags, U cdrivers, UB* table, U cbits);
extern UB* getEvcdStatusByFlagsS(scalar* pscalar, UB* pevcdTBDriverFlags, U cdrivers, UB* table);
extern UB* getSingleDrvEvcdStatusS(UB value, U fTBDriver);
extern UB* getSingleDrvEvcdStatusE(scalar* pscalars, U fTBDriver, U cbits);
extern UB* getSingleDrvEvcdStatusV(scalar* pscalars, U fTBDriver, U cbits);
extern UB* getSingleDrvEvcdStatusW(scalar* pscalars, U fTBDriver, U cbits);
extern UB* getEvcdStatusByDrvEvcdStatus(UB* pdrvevcdStatus, U cdrivers, UB* table, U cbits);
extern void evcdCallback(UP pcode, U cbits);
extern UB* getSavedEvcdStatus(void);
extern void saveEvcdStatus(UB*);
extern void mhdlMarkExport(void*, U);
extern void levelInsertQueue(int);
extern void levelInsertQueueGL(int);
extern void VcsRciRtl(RP pcode);
extern void VcsRciSCompiledLoad(scalar* pcode, scalar ibnVal);
extern U fLoopDetectMode;
extern int gFLoopDectCodeEna;
extern U fLoopReportRT;
extern void rtSched0LoopDectDumpProcess(void* e, void* rtn, void* PQ);
extern void pushHsimRtnCtxt(void* pcode);
extern void popHsimRtnCtxt();
extern EBLK* loopReportInlinedSched0Wrapper(EBLK *peblk);
extern void loopReportSched0Wrapper(EBLK *peblk, unsigned int sfType, unsigned int fTH, struct dummyq_struct* pq);
extern void loopReportSchedSemiLerWrapper(EBLK *peblk, int sfType);
extern void CallGraphPushNodeAndAddToGraph(UP flatNode, UP instNum, U dummy);
extern void CallGraphPopNode(void);
extern RP elabGetIpTpl(U in);
extern U rmaEvalBitBothEdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitEdgeQ1W(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitEdgeQXW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitEdgeQ0W(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEval01EdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEval0XEdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEval10EdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEval1XEdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalX1EdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalX0EdgeW(vec32* pvalCurr, vec32* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitPosEdgeE(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitNegEdgeE(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitBothEdgeE(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitEdgeQ1E(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitEdgeQ0E(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern U rmaEvalBitChangeE(scalar* pvalCurr, scalar* pvalPrev, U cbits, U* pedges);
extern void rmaScheduleNbaGate(RP pcode, scalar val);
extern void rmaEvalRtlEdgeLoads(RmaRtlEdgeBlockHdr *phdr, US clkEdge, scalar clkVal, scalar prevClkVal, scalar val4,   scalar prevval4, scalar master4val);
extern void rmaEvaluateDynamicGateLoadsCg(RP p, scalar s);
extern void rmaEvaluateFusedWithDynamicGateLoadsCg(RP p, scalar s);
extern void rmaScheduleGatedClockEdgeLoadNew(UB* p, US* ea, U flags, UB* plist, UB* pprevlist, scalar v, scalar pv);
extern void rmaScheduleGatedClockEdgeLoad(UB* p, US* ea, U flags, UB* plist, UB* pprevlist, scalar v);
extern void vcsCheckIfClkValValid(U val, U index);
extern void rmaRemoveNonEdgeLoads(UB* pcode);
extern void rmaRecordEvents(HsimNodeRecord *pnr);
extern void handlePCBs(UB* p, U i);
extern void markMasterClkOvaLists(U fdbs, RP p);
extern void rmaChildClockPropAfterWrite(UB* p);
extern void rmaSchedChildClockPropAfterWrite(UB* p, UB* pmasterList, UB val);
extern void rmaChangeListForMovedGates(UB clkVal, UB f10Edge, UB* subMasterVal, UB* plist, RP* p, U count);
extern void rmaEvalSeqPrimLoadsByteArray(UB* pcode, UB val, UB prevval4);
extern void rmaEvalSeqPrimLoadsByteArrayX(UB* pcode, UB val, UB prevval4);
extern void vcsRmaEvalSeqPrimLoadsByteArraySCT(UB* pcode, UB val, UB prevval4, U c);
extern void rmaEvalSimonCellLoadsByteArray(UB* pcode, UB val, UB prevval4);
extern void vcsAbortForBadEBlk(void);
extern scalar edgeChangeLookUp[4][4];
extern void Wsvvar_sched_virt_intf_eval(RP* ptr, char val);
extern void vcs_hwcosim_drive_dut_scalar(U id, char val);
extern void vcs_hwcosim_drive_dut_vector_4state(U id, vec32* val);
extern U vcs_rmaGetClkValForSeqUdpLayoutOnClkOpt(UB* poutput);
extern U rmaIsS2State(scalar s);
extern U rmaIsV2State(vec32* pval, U cbits);
extern U rmaIsW2State(vec32* pval, U cbits);
extern U rmaIsE2State(scalar* pval, U cbits);
extern void rmaUpdateRecordFor2State(HsimNodeRecord* record, U f2state);
typedef void (*FuncPtr)();
static inline U asm_bsf (U in)
{
#if defined(linux)
    U out;
#if !defined(__aarch64__)
    asm ("movl %1, %%eax; bsf %%eax, %%eax; movl %%eax, %0;"
        :"=r"(out)
        :"r"(in)
        :"%eax"
        );
#else
    out = ffs(in) - 1;
#endif
    return out;
#else
    return 0;
#endif
}


#ifdef __cplusplus
extern "C" {
#endif
void  rmaPropagate0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate1_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate2_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate3_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate3_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate4_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate4_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate4_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate5_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate5_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate5_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate6_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate7_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate7_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate7_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate7_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate7_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate8_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate9_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate10_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate10_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate11_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate12_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate12_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate12_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate12_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate12_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate13_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate14_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate14_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate14_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate15_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate15_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate16_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate16_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate17_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate18_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate18_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate19_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate19_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate20_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate20_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate21_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate22_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate23_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate23_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate23_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate24_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate24_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate24_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate25_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate25_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate25_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate26_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate26_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate26_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate27_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate28_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate28_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate28_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate28_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate28_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate29_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate29_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate30_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate30_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate31_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate31_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate32_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate33_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate33_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate33_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate33_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate33_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate34_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate34_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate35_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate35_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate35_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate35_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate35_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate36_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate36_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate37_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate37_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate37_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate37_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate38_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate38_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate38_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate38_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate39_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate39_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate40_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate40_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate41_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate42_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate42_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate42_f_simv_daidir (UB  * pcode, scalar  val, U  I616, scalar  * I1418, U  did);
void  rmaPropagate42_r_simv_daidir (UB  * pcode);
void  rmaPropagate42_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate43_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate44_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate45_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate45_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate47_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate47_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate48_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate49_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate50_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate52_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate53_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate53_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate54_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate54_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate55_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate55_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate55_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate56_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate56_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate56_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate57_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate57_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate57_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate58_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate58_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate58_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate59_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate59_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate60_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate60_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate61_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate62_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate63_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate64_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate64_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate65_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate65_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate66_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate66_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate66_t0_simv_daidir (UB  * pcode, U  I991);
void  rmaPropagate67_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate67_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate67_t0_simv_daidir (UB  * pcode, U  I991);
void  rmaPropagate68_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate69_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate69_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate69_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate70_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate70_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate70_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate71_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate71_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate71_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate72_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate73_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate74_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate75_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate76_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate77_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate78_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate79_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate79_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate79_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate79_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate79_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate80_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate80_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate81_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate81_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate82_simv_daidir (UB  * pcode, scalar  * I1103, U  I991);
void  rmaPropagate82_s0_simv_daidir (UB  * pcode, scalar  * I1103);
void  rmaPropagate83_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate83_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate83_t0_simv_daidir (UB  * pcode, U  I991);
void  rmaPropagate84_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate84_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate84_t0_simv_daidir (UB  * pcode, U  I991);
void  rmaPropagate85_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate86_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate86_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate86_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate87_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate87_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate87_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate88_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate88_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate88_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate89_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate89_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate89_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate90_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate91_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate92_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate93_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate93_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate93_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate94_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate94_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate94_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate95_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate95_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate95_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate95_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate96_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate96_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate96_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate96_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate97_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate97_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate97_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate98_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate99_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate100_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate100_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate101_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate102_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate103_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate103_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate104_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate105_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate105_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate105_t0_simv_daidir (UB  * pcode, U  I991);
void  rmaPropagate106_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate106_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate106_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate107_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate107_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate107_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate108_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate109_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate110_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate111_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate111_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate111_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate112_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate112_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate112_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate113_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate113_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate113_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate114_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate114_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate114_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate115_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate115_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate115_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate116_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate117_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate118_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate118_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate118_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate119_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate119_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate119_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate120_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate120_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate120_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate120_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate121_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate121_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate121_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate121_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate122_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate122_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate122_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate122_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate123_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate123_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate123_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate124_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate124_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate124_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate125_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate125_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate125_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate126_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate127_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate128_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate129_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate130_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate130_s0_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate131_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate131_s0_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate132_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate132_s0_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate133_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate134_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate134_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate134_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate135_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate136_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate137_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate137_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate137_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate138_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate139_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate140_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate141_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate142_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate143_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate144_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate144_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate145_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate146_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate146_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate147_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate147_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate147_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate147_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate147_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  rmaPropagate148_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate148_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate149_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate149_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate149_f_simv_daidir (UB  * pcode, scalar  val, U  I616, scalar  * I1418, U  did);
void  rmaPropagate149_r_simv_daidir (UB  * pcode);
void  rmaPropagate149_t0_simv_daidir (UB  * pcode, UB  val);
void  rmaPropagate150_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate150_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate150_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate151_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate152_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate153_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate153_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate153_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate154_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate154_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate154_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate155_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate155_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate155_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate156_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate157_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate158_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate159_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate160_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate161_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate162_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate163_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate163_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate163_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate164_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate164_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate164_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate165_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate165_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate165_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate166_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate166_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate166_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate167_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate168_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate169_p_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate169_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate169_wn_simv_daidir (UB  * pcode, scalar  val);
void  rmaPropagate170_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate171_p_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate171_simv_daidir (UB  * pcode, vec32  * I1103, U  I991);
void  rmaPropagate171_lbs_simv_daidir (UB  * pcode, scalar  val, U  I966);
void  rmaPropagate171_lps_simv_daidir (UB  * pcode, vec32  * I1478, U  I966, U  I1488);
void  rmaPropagate171_s0f_simv_daidir (UB  * pcode, vec32  * I1103);
void  schedNewEvent (struct dummyq_struct * I1403, EBLK  * I1398, U  I624);
#ifdef __cplusplus
}
#endif

#ifdef __cplusplus
  }
#endif
#endif /*__DO_RMAHDR_*/

