#ifndef _VC_HDRS_H
#define _VC_HDRS_H

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif
#include <stdio.h>
#include <dlfcn.h>
#include "svdpi.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _VC_TYPES_
#define _VC_TYPES_
/* common definitions shared with DirectC.h */

typedef unsigned int U;
typedef unsigned char UB;
typedef unsigned char scalar;
typedef struct { U c; U d;} vec32;

#define scalar_0 0
#define scalar_1 1
#define scalar_z 2
#define scalar_x 3

extern long long int ConvUP2LLI(U* a);
extern void ConvLLI2UP(long long int a1, U* a2);
extern long long int GetLLIresult();
extern void StoreLLIresult(const unsigned int* data);
typedef struct VeriC_Descriptor *vc_handle;

#ifndef SV_3_COMPATIBILITY
#define SV_STRING const char*
#else
#define SV_STRING char*
#endif

#endif /* _VC_TYPES_ */


 extern void questa_mvc_sv_show(/* INPUT */const char* show_command);

 extern void questa_mvc_sv_do_cmd(/* INPUT */const char* command);

 extern long long questa_mvc_sv_convert_to_precision(/* INPUT */long long time_value, /* INPUT */int time_unit);

 extern double questa_mvc_sv_convert_real_to_precision(/* INPUT */double time_value, /* INPUT */int time_unit);

 extern SV_STRING questa_vip_get_version(/* INPUT */const char* version);

 extern SV_STRING questa_vip_get_platform();

 extern SV_STRING questa_mvc_sv_home();

 extern long long dvc_axi4_initialise_SystemVerilog(/* INPUT */int usage_code, /* INPUT */const char* iface_version, /* INPUT */long long generate_ver, /* INPUT */int qvip_mix_and_match, /* OUTPUT */long long *master_end, /* OUTPUT */long long *slave_end, /* OUTPUT */long long *_monitor_end, /* INPUT */int AXI4_ADDRESS_WIDTH, /* INPUT */int AXI4_RDATA_WIDTH, /* INPUT */int AXI4_WDATA_WIDTH, 
/* INPUT */int AXI4_ID_WIDTH, /* INPUT */int AXI4_USER_WIDTH, /* INPUT */int AXI4_REGION_MAP_SIZE);

 extern void dvc_axi4_process_reports(/* INPUT */long long recipient, /* INPUT */const char* category, /* INPUT */const char* objectName, /* INPUT */const char* instanceName, /* INPUT */const char* error_no, /* INPUT */const char* severity, /* INPUT */const char* mess);

 extern void dvc_axi4_register_end_point(/* INPUT */long long iface_ref, /* INPUT */long long as_end, /* INPUT */const char* name);

 extern void dvc_axi4_get_temp_static_fn_get_raddr_phase_info_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_fn_get_raddr_phase_info_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_fn_get_waddr_phase_info_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_fn_get_waddr_phase_info_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_fn_add_addr_map_entry_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_fn_add_addr_map_entry_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_fn_add_wr_delay_data2data(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_fn_add_wr_delay_data2data(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_get_temp_static_fn_set_address_map_entry_start_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_fn_set_address_map_entry_start_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_fn_set_address_map_entry_end_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_fn_set_address_map_entry_end_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_fn_set_wr_def_delays_min_data2data(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_fn_set_wr_def_delays_min_data2data(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_get_temp_static_fn_set_wr_def_delays_max_data2data(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_fn_set_wr_def_delays_max_data2data(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_set_start_end_times(/* INPUT */long long _start, /* INPUT */long long _end);

 extern void dvc_axi4_get_temp_static_rw_transaction_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_addr_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_addr_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_wdata_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_wdata_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_resp(/* INPUT */int _d1, /* OUTPUT */svBitVecVal *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_resp(/* INPUT */int _d1, const /* INPUT */svBitVecVal *_value);

 extern void dvc_axi4_get_temp_static_rw_transaction_resp_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_resp_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_data_valid_delay(/* INPUT */int _d1, /* OUTPUT */int *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_data_valid_delay(/* INPUT */int _d1, /* INPUT */int _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_data_ready_delay(/* INPUT */int _d1, /* OUTPUT */int *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_data_ready_delay(/* INPUT */int _d1, /* INPUT */int _value);

 extern void dvc_axi4_get_temp_static_rw_transaction_write_data_beats_delay(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_rw_transaction_write_data_beats_delay(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_get_temp_static_read_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_rresp_delays(/* INPUT */int _d1, /* OUTPUT */int *_value);

 extern void dvc_axi4_set_temp_static_read_rresp_delays(/* INPUT */int _d1, /* INPUT */int _value);

 extern void dvc_axi4_get_temp_static_read_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_resp(/* INPUT */int _d1, /* OUTPUT */svBitVecVal *_value);

 extern void dvc_axi4_set_temp_static_read_resp(/* INPUT */int _d1, const /* INPUT */svBitVecVal *_value);

 extern void dvc_axi4_get_temp_static_read_resp_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_resp_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_data_start_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_read_data_start_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_read_data_end_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_read_data_end_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_write_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_wdata_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_wdata_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_resp_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_resp_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_data_start_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_write_data_start_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_write_data_end_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_write_data_end_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_write_write_data_beats_delay(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_write_write_data_beats_delay(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_data_words(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_write_strobes(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_user_data(/* INPUT */int _d1, /* INPUT */int _d2, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_data_start_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_data_start_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_data_end_time(/* INPUT */int _d1, /* OUTPUT */long long *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_data_end_time(/* INPUT */int _d1, /* INPUT */long long _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_write_data_beats_delay(/* INPUT */int _d1, /* OUTPUT */unsigned int *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_write_data_beats_delay(/* INPUT */int _d1, /* INPUT */unsigned int _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_data_valid2ready(/* INPUT */int _d1, /* OUTPUT */int *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_data_valid2ready(/* INPUT */int _d1, /* INPUT */int _value);

 extern void dvc_axi4_get_temp_static_write_data_burst_data2data_clock(/* INPUT */int _d1, /* OUTPUT */int *_value);

 extern void dvc_axi4_set_temp_static_write_data_burst_data2data_clock(/* INPUT */int _d1, /* INPUT */int _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_phase_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_phase_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_phase_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_phase_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_phase_addr_user(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_phase_addr_user(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_phase_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_phase_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_phase_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_phase_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_phase_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_phase_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_phase_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_phase_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_phase_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_phase_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_phase_addr_user(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_phase_addr_user(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_phase_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_phase_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_phase_write_strobes(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_phase_write_strobes(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_phase_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_phase_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_resp_channel_phase_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_resp_channel_phase_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_resp_channel_phase_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_resp_channel_phase_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_cycle_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_cycle_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_cycle_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_cycle_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_addr_channel_cycle_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_addr_channel_cycle_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_cycle_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_cycle_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_cycle_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_cycle_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_read_channel_cycle_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_read_channel_cycle_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_cycle_addr(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_cycle_addr(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_cycle_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_cycle_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_addr_channel_cycle_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_addr_channel_cycle_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_cycle_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_cycle_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_cycle_strb(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_cycle_strb(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_channel_cycle_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_channel_cycle_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_resp_channel_cycle_id(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_resp_channel_cycle_id(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_get_temp_static_write_resp_channel_cycle_user_data(/* INPUT */int _d1, /* OUTPUT */unsigned char *_value);

 extern void dvc_axi4_set_temp_static_write_resp_channel_cycle_user_data(/* INPUT */int _d1, /* INPUT */unsigned char _value);

 extern void dvc_axi4_set_interface(/* INPUT */int what, /* INPUT */int arg1, /* INPUT */int arg2, /* INPUT */int arg3, /* INPUT */int arg4, /* INPUT */int arg5, /* INPUT */int arg6, /* INPUT */int arg7, /* INPUT */int arg8, /* INPUT */int arg9, 
/* INPUT */int arg10);

 extern int dvc_axi4_get_interface(/* INPUT */int what, /* INPUT */int arg1, /* INPUT */int arg2, /* INPUT */int arg3, /* INPUT */int arg4, /* INPUT */int arg5, /* INPUT */int arg6, /* INPUT */int arg7, /* INPUT */int arg8, /* INPUT */int arg9
);

 extern SV_STRING dvc_axi4_get_full_name();

 extern void dvc_axi4_set_master_end_abstraction_level(/* INPUT */unsigned char wire_level, /* INPUT */unsigned char TLM_level);

 extern void dvc_axi4_get_master_end_abstraction_level(/* OUTPUT */unsigned char *wire_level, /* OUTPUT */unsigned char *TLM_level);

 extern void dvc_axi4_set_slave_end_abstraction_level(/* INPUT */unsigned char wire_level, /* INPUT */unsigned char TLM_level);

 extern void dvc_axi4_get_slave_end_abstraction_level(/* OUTPUT */unsigned char *wire_level, /* OUTPUT */unsigned char *TLM_level);

 extern void dvc_axi4_set_ACLK_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char ACLK_param);

 extern void dvc_axi4_get_ACLK_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *ACLK_param);

 extern void dvc_axi4_set_ARESETn_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char ARESETn_param);

 extern void dvc_axi4_get_ARESETn_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *ARESETn_param);

 extern void dvc_axi4_set_AWVALID_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char AWVALID_param);

 extern void dvc_axi4_get_AWVALID_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *AWVALID_param);

 extern void dvc_axi4_set_AWADDR_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char AWADDR_param);

 extern void dvc_axi4_propagate_AWADDR_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_AWADDR_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_AWPROT_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWPROT_param);

 extern void dvc_axi4_get_AWPROT_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWPROT_param);

 extern void dvc_axi4_set_AWREGION_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWREGION_param);

 extern void dvc_axi4_get_AWREGION_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWREGION_param);

 extern void dvc_axi4_set_AWLEN_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWLEN_param);

 extern void dvc_axi4_get_AWLEN_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWLEN_param);

 extern void dvc_axi4_set_AWSIZE_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWSIZE_param);

 extern void dvc_axi4_get_AWSIZE_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWSIZE_param);

 extern void dvc_axi4_set_AWBURST_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWBURST_param);

 extern void dvc_axi4_get_AWBURST_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWBURST_param);

 extern void dvc_axi4_set_AWLOCK_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char AWLOCK_param);

 extern void dvc_axi4_get_AWLOCK_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *AWLOCK_param);

 extern void dvc_axi4_set_AWCACHE_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWCACHE_param);

 extern void dvc_axi4_get_AWCACHE_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWCACHE_param);

 extern void dvc_axi4_set_AWQOS_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *AWQOS_param);

 extern void dvc_axi4_get_AWQOS_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *AWQOS_param);

 extern void dvc_axi4_set_AWID_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char AWID_param);

 extern void dvc_axi4_propagate_AWID_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_AWID_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_AWUSER_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char AWUSER_param);

 extern void dvc_axi4_propagate_AWUSER_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_AWUSER_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_AWREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char AWREADY_param);

 extern void dvc_axi4_get_AWREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *AWREADY_param);

 extern void dvc_axi4_set_ARVALID_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char ARVALID_param);

 extern void dvc_axi4_get_ARVALID_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *ARVALID_param);

 extern void dvc_axi4_set_ARADDR_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char ARADDR_param);

 extern void dvc_axi4_propagate_ARADDR_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_ARADDR_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_ARPROT_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARPROT_param);

 extern void dvc_axi4_get_ARPROT_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARPROT_param);

 extern void dvc_axi4_set_ARREGION_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARREGION_param);

 extern void dvc_axi4_get_ARREGION_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARREGION_param);

 extern void dvc_axi4_set_ARLEN_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARLEN_param);

 extern void dvc_axi4_get_ARLEN_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARLEN_param);

 extern void dvc_axi4_set_ARSIZE_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARSIZE_param);

 extern void dvc_axi4_get_ARSIZE_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARSIZE_param);

 extern void dvc_axi4_set_ARBURST_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARBURST_param);

 extern void dvc_axi4_get_ARBURST_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARBURST_param);

 extern void dvc_axi4_set_ARLOCK_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char ARLOCK_param);

 extern void dvc_axi4_get_ARLOCK_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *ARLOCK_param);

 extern void dvc_axi4_set_ARCACHE_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARCACHE_param);

 extern void dvc_axi4_get_ARCACHE_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARCACHE_param);

 extern void dvc_axi4_set_ARQOS_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *ARQOS_param);

 extern void dvc_axi4_get_ARQOS_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *ARQOS_param);

 extern void dvc_axi4_set_ARID_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char ARID_param);

 extern void dvc_axi4_propagate_ARID_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_ARID_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_ARUSER_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char ARUSER_param);

 extern void dvc_axi4_propagate_ARUSER_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_ARUSER_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_ARREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char ARREADY_param);

 extern void dvc_axi4_get_ARREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *ARREADY_param);

 extern void dvc_axi4_set_RVALID_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char RVALID_param);

 extern void dvc_axi4_get_RVALID_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *RVALID_param);

 extern void dvc_axi4_set_RDATA_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char RDATA_param);

 extern void dvc_axi4_propagate_RDATA_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_RDATA_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_RRESP_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *RRESP_param);

 extern void dvc_axi4_get_RRESP_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *RRESP_param);

 extern void dvc_axi4_set_RLAST_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char RLAST_param);

 extern void dvc_axi4_get_RLAST_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *RLAST_param);

 extern void dvc_axi4_set_RID_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char RID_param);

 extern void dvc_axi4_propagate_RID_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_RID_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_RUSER_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char RUSER_param);

 extern void dvc_axi4_propagate_RUSER_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_RUSER_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_RREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char RREADY_param);

 extern void dvc_axi4_get_RREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *RREADY_param);

 extern void dvc_axi4_set_WVALID_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char WVALID_param);

 extern void dvc_axi4_get_WVALID_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *WVALID_param);

 extern void dvc_axi4_set_WDATA_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char WDATA_param);

 extern void dvc_axi4_propagate_WDATA_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_WDATA_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_WSTRB_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char WSTRB_param);

 extern void dvc_axi4_propagate_WSTRB_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_WSTRB_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_WLAST_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char WLAST_param);

 extern void dvc_axi4_get_WLAST_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *WLAST_param);

 extern void dvc_axi4_set_WUSER_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char WUSER_param);

 extern void dvc_axi4_propagate_WUSER_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_WUSER_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_WREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char WREADY_param);

 extern void dvc_axi4_get_WREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *WREADY_param);

 extern void dvc_axi4_set_BVALID_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char BVALID_param);

 extern void dvc_axi4_get_BVALID_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *BVALID_param);

 extern void dvc_axi4_set_BRESP_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svLogicVecVal *BRESP_param);

 extern void dvc_axi4_get_BRESP_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svLogicVecVal *BRESP_param);

 extern void dvc_axi4_set_BID_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char BID_param);

 extern void dvc_axi4_propagate_BID_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_BID_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_BUSER_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char BUSER_param);

 extern void dvc_axi4_propagate_BUSER_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_BUSER_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_BREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char BREADY_param);

 extern void dvc_axi4_get_BREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *BREADY_param);

 extern void dvc_axi4_set_config_axi4lite_interface_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_axi4lite_interface_param);

 extern void dvc_axi4_get_config_axi4lite_interface_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_axi4lite_interface_param);

 extern void dvc_axi4_set_config_interface_type_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svBitVecVal *config_interface_type_param);

 extern void dvc_axi4_get_config_interface_type_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svBitVecVal *config_interface_type_param);

 extern void dvc_axi4_set_config_enable_rlast_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_rlast_param);

 extern void dvc_axi4_get_config_enable_rlast_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_rlast_param);

 extern void dvc_axi4_set_config_enable_id_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_id_param);

 extern void dvc_axi4_get_config_enable_id_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_id_param);

 extern void dvc_axi4_set_config_enable_all_assertions_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_all_assertions_param);

 extern void dvc_axi4_get_config_enable_all_assertions_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_all_assertions_param);

 extern void dvc_axi4_set_config_enable_assertion_from_SystemVerilog(/* INPUT */long long _iface_ref, const /* INPUT */svBitVecVal *config_enable_assertion_param);

 extern void dvc_axi4_get_config_enable_assertion_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */svBitVecVal *config_enable_assertion_param);

 extern void dvc_axi4_set_config_enable_user_sideband_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_user_sideband_param);

 extern void dvc_axi4_get_config_enable_user_sideband_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_user_sideband_param);

 extern void dvc_axi4_set_config_enable_slave_exclusive_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_slave_exclusive_param);

 extern void dvc_axi4_get_config_enable_slave_exclusive_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_slave_exclusive_param);

 extern void dvc_axi4_set_config_read_data_reordering_depth_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_read_data_reordering_depth_param);

 extern void dvc_axi4_get_config_read_data_reordering_depth_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_read_data_reordering_depth_param);

 extern void dvc_axi4_set_config_slave_start_addr_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char config_slave_start_addr_param);

 extern void dvc_axi4_propagate_config_slave_start_addr_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_deprecated_config_slave_start_addr_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_config_slave_start_addr_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_config_slave_end_addr_from_SystemVerilog_index1(/* INPUT */long long _iface_ref, /* INPUT */unsigned int _this_dot_1, /* INPUT */unsigned char config_slave_end_addr_param);

 extern void dvc_axi4_propagate_config_slave_end_addr_from_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_deprecated_config_slave_end_addr_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_get_config_slave_end_addr_into_SystemVerilog(/* INPUT */long long _iface_ref);

 extern void dvc_axi4_set_config_max_transaction_time_factor_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_transaction_time_factor_param);

 extern void dvc_axi4_get_config_max_transaction_time_factor_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_transaction_time_factor_param);

 extern void dvc_axi4_set_config_burst_timeout_factor_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_burst_timeout_factor_param);

 extern void dvc_axi4_get_config_burst_timeout_factor_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_burst_timeout_factor_param);

 extern void dvc_axi4_set_config_max_latency_AWVALID_assertion_to_AWREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_latency_AWVALID_assertion_to_AWREADY_param);

 extern void dvc_axi4_get_config_max_latency_AWVALID_assertion_to_AWREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_latency_AWVALID_assertion_to_AWREADY_param);

 extern void dvc_axi4_set_config_max_latency_ARVALID_assertion_to_ARREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_latency_ARVALID_assertion_to_ARREADY_param);

 extern void dvc_axi4_get_config_max_latency_ARVALID_assertion_to_ARREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_latency_ARVALID_assertion_to_ARREADY_param);

 extern void dvc_axi4_set_config_max_latency_RVALID_assertion_to_RREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_latency_RVALID_assertion_to_RREADY_param);

 extern void dvc_axi4_get_config_max_latency_RVALID_assertion_to_RREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_latency_RVALID_assertion_to_RREADY_param);

 extern void dvc_axi4_set_config_max_latency_BVALID_assertion_to_BREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_latency_BVALID_assertion_to_BREADY_param);

 extern void dvc_axi4_get_config_max_latency_BVALID_assertion_to_BREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_latency_BVALID_assertion_to_BREADY_param);

 extern void dvc_axi4_set_config_max_latency_WVALID_assertion_to_WREADY_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned int config_max_latency_WVALID_assertion_to_WREADY_param);

 extern void dvc_axi4_get_config_max_latency_WVALID_assertion_to_WREADY_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned int *config_max_latency_WVALID_assertion_to_WREADY_param);

 extern void dvc_axi4_set_config_enable_qos_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_enable_qos_param);

 extern void dvc_axi4_get_config_enable_qos_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_enable_qos_param);

 extern void dvc_axi4_set_config_setup_time_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned long long config_setup_time_param);

 extern void dvc_axi4_get_config_setup_time_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned long long *config_setup_time_param);

 extern void dvc_axi4_set_config_hold_time_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned long long config_hold_time_param);

 extern void dvc_axi4_get_config_hold_time_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned long long *config_hold_time_param);

 extern void dvc_axi4_set_config_num_max_outstanding_reads_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_num_max_outstanding_reads_param);

 extern void dvc_axi4_get_config_num_max_outstanding_reads_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_num_max_outstanding_reads_param);

 extern void dvc_axi4_set_config_num_max_outstanding_writes_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_num_max_outstanding_writes_param);

 extern void dvc_axi4_get_config_num_max_outstanding_writes_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_num_max_outstanding_writes_param);

 extern void dvc_axi4_set_config_max_outstanding_wr_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_max_outstanding_wr_param);

 extern void dvc_axi4_get_config_max_outstanding_wr_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_max_outstanding_wr_param);

 extern void dvc_axi4_set_config_max_outstanding_rd_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_max_outstanding_rd_param);

 extern void dvc_axi4_get_config_max_outstanding_rd_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_max_outstanding_rd_param);

 extern void dvc_axi4_set_config_max_outstanding_rw_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_max_outstanding_rw_param);

 extern void dvc_axi4_get_config_max_outstanding_rw_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_max_outstanding_rw_param);

 extern void dvc_axi4_set_config_num_outstanding_wr_phase_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_num_outstanding_wr_phase_param);

 extern void dvc_axi4_get_config_num_outstanding_wr_phase_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_num_outstanding_wr_phase_param);

 extern void dvc_axi4_set_config_num_outstanding_rd_phase_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */int config_num_outstanding_rd_phase_param);

 extern void dvc_axi4_get_config_num_outstanding_rd_phase_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */int *config_num_outstanding_rd_phase_param);

 extern void dvc_axi4_set_config_is_issuing_from_SystemVerilog(/* INPUT */long long _iface_ref, /* INPUT */unsigned char config_is_issuing_param);

 extern void dvc_axi4_get_config_is_issuing_into_SystemVerilog(/* INPUT */long long _iface_ref, /* OUTPUT */unsigned char *config_is_issuing_param);

 extern void dvc_axi4_initialise_ACLK_from_CY();

 extern void dvc_axi4_initialise_ARESETn_from_CY();

 extern void dvc_axi4_initialise_AWVALID_from_CY();

 extern void dvc_axi4_set_AWADDR_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char AWADDR_param);

 extern void dvc_axi4_initialise_AWADDR_from_CY();

 extern void dvc_axi4_initialise_AWPROT_from_CY();

 extern void dvc_axi4_initialise_AWREGION_from_CY();

 extern void dvc_axi4_initialise_AWLEN_from_CY();

 extern void dvc_axi4_initialise_AWSIZE_from_CY();

 extern void dvc_axi4_initialise_AWBURST_from_CY();

 extern void dvc_axi4_initialise_AWLOCK_from_CY();

 extern void dvc_axi4_initialise_AWCACHE_from_CY();

 extern void dvc_axi4_initialise_AWQOS_from_CY();

 extern void dvc_axi4_set_AWID_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char AWID_param);

 extern void dvc_axi4_initialise_AWID_from_CY();

 extern void dvc_axi4_set_AWUSER_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char AWUSER_param);

 extern void dvc_axi4_initialise_AWUSER_from_CY();

 extern void dvc_axi4_initialise_AWREADY_from_CY();

 extern void dvc_axi4_initialise_ARVALID_from_CY();

 extern void dvc_axi4_set_ARADDR_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char ARADDR_param);

 extern void dvc_axi4_initialise_ARADDR_from_CY();

 extern void dvc_axi4_initialise_ARPROT_from_CY();

 extern void dvc_axi4_initialise_ARREGION_from_CY();

 extern void dvc_axi4_initialise_ARLEN_from_CY();

 extern void dvc_axi4_initialise_ARSIZE_from_CY();

 extern void dvc_axi4_initialise_ARBURST_from_CY();

 extern void dvc_axi4_initialise_ARLOCK_from_CY();

 extern void dvc_axi4_initialise_ARCACHE_from_CY();

 extern void dvc_axi4_initialise_ARQOS_from_CY();

 extern void dvc_axi4_set_ARID_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char ARID_param);

 extern void dvc_axi4_initialise_ARID_from_CY();

 extern void dvc_axi4_set_ARUSER_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char ARUSER_param);

 extern void dvc_axi4_initialise_ARUSER_from_CY();

 extern void dvc_axi4_initialise_ARREADY_from_CY();

 extern void dvc_axi4_initialise_RVALID_from_CY();

 extern void dvc_axi4_set_RDATA_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char RDATA_param);

 extern void dvc_axi4_initialise_RDATA_from_CY();

 extern void dvc_axi4_initialise_RRESP_from_CY();

 extern void dvc_axi4_initialise_RLAST_from_CY();

 extern void dvc_axi4_set_RID_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char RID_param);

 extern void dvc_axi4_initialise_RID_from_CY();

 extern void dvc_axi4_set_RUSER_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char RUSER_param);

 extern void dvc_axi4_initialise_RUSER_from_CY();

 extern void dvc_axi4_initialise_RREADY_from_CY();

 extern void dvc_axi4_initialise_WVALID_from_CY();

 extern void dvc_axi4_set_WDATA_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char WDATA_param);

 extern void dvc_axi4_initialise_WDATA_from_CY();

 extern void dvc_axi4_set_WSTRB_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char WSTRB_param);

 extern void dvc_axi4_initialise_WSTRB_from_CY();

 extern void dvc_axi4_initialise_WLAST_from_CY();

 extern void dvc_axi4_set_WUSER_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char WUSER_param);

 extern void dvc_axi4_initialise_WUSER_from_CY();

 extern void dvc_axi4_initialise_WREADY_from_CY();

 extern void dvc_axi4_initialise_BVALID_from_CY();

 extern void dvc_axi4_initialise_BRESP_from_CY();

 extern void dvc_axi4_set_BID_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char BID_param);

 extern void dvc_axi4_initialise_BID_from_CY();

 extern void dvc_axi4_set_BUSER_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char BUSER_param);

 extern void dvc_axi4_initialise_BUSER_from_CY();

 extern void dvc_axi4_initialise_BREADY_from_CY();

 extern void dvc_axi4_set_config_axi4lite_interface_from_CY(/* INPUT */unsigned char config_axi4lite_interface_param);

 extern void dvc_axi4_set_config_interface_type_from_CY(const /* INPUT */svBitVecVal *config_interface_type_param);

 extern void dvc_axi4_set_config_enable_rlast_from_CY(/* INPUT */unsigned char config_enable_rlast_param);

 extern void dvc_axi4_set_config_enable_id_from_CY(/* INPUT */unsigned char config_enable_id_param);

 extern void dvc_axi4_set_config_enable_all_assertions_from_CY(/* INPUT */unsigned char config_enable_all_assertions_param);

 extern void dvc_axi4_set_config_enable_assertion_from_CY(const /* INPUT */svBitVecVal *config_enable_assertion_param);

 extern void dvc_axi4_set_config_enable_user_sideband_from_CY(/* INPUT */unsigned char config_enable_user_sideband_param);

 extern void dvc_axi4_set_config_enable_slave_exclusive_from_CY(/* INPUT */unsigned char config_enable_slave_exclusive_param);

 extern void dvc_axi4_set_config_read_data_reordering_depth_from_CY(/* INPUT */unsigned int config_read_data_reordering_depth_param);

 extern void dvc_axi4_set_config_slave_start_addr_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char config_slave_start_addr_param);

 extern void dvc_axi4_set_config_slave_end_addr_from_CY_index1(/* INPUT */int _this_dot_1, /* INPUT */unsigned char config_slave_end_addr_param);

 extern void dvc_axi4_set_config_max_transaction_time_factor_from_CY(/* INPUT */unsigned int config_max_transaction_time_factor_param);

 extern void dvc_axi4_set_config_burst_timeout_factor_from_CY(/* INPUT */unsigned int config_burst_timeout_factor_param);

 extern void dvc_axi4_set_config_max_latency_AWVALID_assertion_to_AWREADY_from_CY(/* INPUT */unsigned int config_max_latency_AWVALID_assertion_to_AWREADY_param);

 extern void dvc_axi4_set_config_max_latency_ARVALID_assertion_to_ARREADY_from_CY(/* INPUT */unsigned int config_max_latency_ARVALID_assertion_to_ARREADY_param);

 extern void dvc_axi4_set_config_max_latency_RVALID_assertion_to_RREADY_from_CY(/* INPUT */unsigned int config_max_latency_RVALID_assertion_to_RREADY_param);

 extern void dvc_axi4_set_config_max_latency_BVALID_assertion_to_BREADY_from_CY(/* INPUT */unsigned int config_max_latency_BVALID_assertion_to_BREADY_param);

 extern void dvc_axi4_set_config_max_latency_WVALID_assertion_to_WREADY_from_CY(/* INPUT */unsigned int config_max_latency_WVALID_assertion_to_WREADY_param);

 extern void dvc_axi4_set_config_enable_qos_from_CY(/* INPUT */unsigned char config_enable_qos_param);

 extern void dvc_axi4_set_config_setup_time_from_CY(/* INPUT */unsigned long long config_setup_time_param);

 extern void dvc_axi4_set_config_hold_time_from_CY(/* INPUT */unsigned long long config_hold_time_param);

 extern void dvc_axi4_set_config_num_max_outstanding_reads_from_CY(/* INPUT */int config_num_max_outstanding_reads_param);

 extern void dvc_axi4_set_config_num_max_outstanding_writes_from_CY(/* INPUT */int config_num_max_outstanding_writes_param);

 extern void dvc_axi4_set_config_max_outstanding_wr_from_CY(/* INPUT */int config_max_outstanding_wr_param);

 extern void dvc_axi4_set_config_max_outstanding_rd_from_CY(/* INPUT */int config_max_outstanding_rd_param);

 extern void dvc_axi4_set_config_max_outstanding_rw_from_CY(/* INPUT */int config_max_outstanding_rw_param);

 extern void dvc_axi4_set_config_num_outstanding_wr_phase_from_CY(/* INPUT */int config_num_outstanding_wr_phase_param);

 extern void dvc_axi4_set_config_num_outstanding_rd_phase_from_CY(/* INPUT */int config_num_outstanding_rd_phase_param);

 extern void dvc_axi4_set_config_is_issuing_from_CY(/* INPUT */unsigned char config_is_issuing_param);

 extern void dvc_axi4_rw_transaction_ActivatesActivatingActivate_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */svBitVecVal *read_or_write, /* INOUT */svBitVecVal *prot, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, 
/* INOUT */svBitVecVal *qos, /* INOUT */svBitVecVal *burst_length, /* INOUT */int *data_words_DIMS0, /* INOUT */int *write_strobes_DIMS0, /* INOUT */int *wdata_user_data_DIMS0, /* INOUT */int *resp_DIMS0, /* INOUT */int *resp_user_data_DIMS0, /* INOUT */int *address_valid_delay, /* INOUT */int *data_valid_delay_DIMS0, /* INOUT */int *write_response_valid_delay, 
/* INOUT */int *address_ready_delay, /* INOUT */int *data_ready_delay_DIMS0, /* INOUT */int *write_response_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_rw_transaction_ActivatesActivatingActivate_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* INOUT */svBitVecVal *read_or_write, /* INOUT */svBitVecVal *prot, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, 
/* INOUT */svBitVecVal *qos, /* INOUT */svBitVecVal *burst_length, /* INOUT */int *address_valid_delay, /* INOUT */int *write_response_valid_delay, /* INOUT */int *address_ready_delay, /* INOUT */int *write_response_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_rw_transaction_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */int *data_words_DIMS0, /* INOUT */int *write_strobes_DIMS0, /* INOUT */int *wdata_user_data_DIMS0, /* INOUT */int *resp_DIMS0, /* INOUT */int *resp_user_data_DIMS0, /* INOUT */int *data_valid_delay_DIMS0, /* INOUT */int *data_ready_delay_DIMS0, 
/* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_rw_transaction_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *read_or_write, /* OUTPUT */svBitVecVal *prot, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *cache, 
/* OUTPUT */svBitVecVal *qos, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */int *address_valid_delay, /* OUTPUT */int *write_response_valid_delay, /* OUTPUT */int *address_ready_delay, /* OUTPUT */int *write_response_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_ActivatesActivatingActivate_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */svBitVecVal *prot, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, /* INOUT */svBitVecVal *qos, 
/* INOUT */svBitVecVal *burst_length, /* INOUT */int *data_words_DIMS0, /* INOUT */int *resp_DIMS0, /* INOUT */int *resp_user_data_DIMS0, /* INOUT */long long *addr_start_time, /* INOUT */long long *addr_end_time, /* INOUT */int *data_start_time_DIMS0, /* INOUT */int *data_end_time_DIMS0, /* INOUT */int *address_valid_delay, /* INPUT */int _unit_id
);

 extern void dvc_axi4_read_ActivatesActivatingActivate_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* INOUT */svBitVecVal *prot, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, /* INOUT */svBitVecVal *qos, 
/* INOUT */svBitVecVal *burst_length, /* INOUT */long long *addr_start_time, /* INOUT */long long *addr_end_time, /* INOUT */int *address_valid_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */int *data_words_DIMS0, /* INOUT */int *resp_DIMS0, /* INOUT */int *resp_user_data_DIMS0, /* INOUT */int *data_start_time_DIMS0, /* INOUT */int *data_end_time_DIMS0, /* INPUT */int _unit_id, /* INPUT */unsigned char _using
);

 extern void dvc_axi4_read_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *prot, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *cache, /* OUTPUT */svBitVecVal *qos, 
/* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */long long *addr_start_time, /* OUTPUT */long long *addr_end_time, /* OUTPUT */int *address_valid_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_ActivatesActivatingActivate_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */svBitVecVal *prot, /* INOUT */int *bresp_delay, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, 
/* INOUT */svBitVecVal *qos, /* INOUT */svBitVecVal *burst_length, /* INOUT */int *data_words_DIMS0, /* INOUT */int *write_strobes_DIMS0, /* INOUT */int *wdata_user_data_DIMS0, /* INOUT */svBitVecVal *resp, /* INOUT */long long *addr_start_time, /* INOUT */long long *addr_end_time, /* INOUT */int *data_start_time_DIMS0, /* INOUT */int *data_end_time_DIMS0, 
/* INOUT */long long *wr_resp_start_time, /* INOUT */long long *wr_resp_end_time, /* INOUT */int *address_valid_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_ActivatesActivatingActivate_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* INOUT */svBitVecVal *prot, /* INOUT */int *bresp_delay, /* INOUT */svBitVecVal *region, /* INOUT */svBitVecVal *size, /* INOUT */svBitVecVal *burst, /* INOUT */svBitVecVal *lock, /* INOUT */svBitVecVal *cache, 
/* INOUT */svBitVecVal *qos, /* INOUT */svBitVecVal *burst_length, /* INOUT */svBitVecVal *resp, /* INOUT */long long *addr_start_time, /* INOUT */long long *addr_end_time, /* INOUT */long long *wr_resp_start_time, /* INOUT */long long *wr_resp_end_time, /* INOUT */int *address_valid_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */int *data_words_DIMS0, /* INOUT */int *write_strobes_DIMS0, /* INOUT */int *wdata_user_data_DIMS0, /* INOUT */int *data_start_time_DIMS0, /* INOUT */int *data_end_time_DIMS0, /* INPUT */int _unit_id, /* INPUT */unsigned char _using
);

 extern void dvc_axi4_write_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *prot, /* OUTPUT */int *bresp_delay, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *cache, 
/* OUTPUT */svBitVecVal *qos, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */svBitVecVal *resp, /* OUTPUT */long long *addr_start_time, /* OUTPUT */long long *addr_end_time, /* OUTPUT */long long *wr_resp_start_time, /* OUTPUT */long long *wr_resp_end_time, /* OUTPUT */int *address_valid_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using
);

 extern void dvc_axi4_write_data_burst_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int burst_length, /* INPUT */int data_words_DIMS0, /* INPUT */int write_strobes_DIMS0, /* INPUT */int user_data_DIMS0, /* INPUT */int data_start_time_DIMS0, /* INPUT */int data_end_time_DIMS0, /* INPUT */int data_valid2ready_DIMS0, /* INPUT */int data2data_clock_DIMS0, 
/* INPUT */int wdata_burst_start_clock, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_data_burst_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INOUT */int *data_words_DIMS0, /* INOUT */int *write_strobes_DIMS0, /* INOUT */int *user_data_DIMS0, /* INOUT */int *data_start_time_DIMS0, /* INOUT */int *data_end_time_DIMS0, /* INOUT */int *data_valid2ready_DIMS0, /* INOUT */int *data2data_clock_DIMS0, 
/* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_data_burst_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */int *burst_length, /* OUTPUT */int *wdata_burst_start_clock, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_addr_channel_phase_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *prot, const /* INPUT */svBitVecVal *region, const /* INPUT */svBitVecVal *burst_length, const /* INPUT */svBitVecVal *size, const /* INPUT */svBitVecVal *burst, const /* INPUT */svBitVecVal *lock, const /* INPUT */svBitVecVal *cache, const /* INPUT */svBitVecVal *qos, 
/* INPUT */int address_valid_delay, /* INPUT */int address_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_addr_channel_phase_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_addr_channel_phase_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *prot, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *cache, 
/* OUTPUT */svBitVecVal *qos, /* OUTPUT */int *address_valid_delay, /* OUTPUT */int *address_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_data_burst_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_data_burst_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_channel_phase_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *resp, /* INPUT */unsigned char last, /* INPUT */int data_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_channel_phase_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_channel_phase_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *resp, /* OUTPUT */unsigned char *last, /* OUTPUT */int *data_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_addr_channel_phase_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *prot, const /* INPUT */svBitVecVal *region, const /* INPUT */svBitVecVal *burst_length, const /* INPUT */svBitVecVal *size, const /* INPUT */svBitVecVal *burst, const /* INPUT */svBitVecVal *lock, const /* INPUT */svBitVecVal *cache, const /* INPUT */svBitVecVal *qos, 
/* INPUT */int address_valid_delay, /* INPUT */int address_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_addr_channel_phase_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_addr_channel_phase_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *prot, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *cache, 
/* OUTPUT */svBitVecVal *qos, /* OUTPUT */int *address_valid_delay, /* OUTPUT */int *address_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_channel_phase_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char last, /* INPUT */int data_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_channel_phase_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_channel_phase_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */unsigned char *last, /* OUTPUT */int *data_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_resp_channel_phase_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *resp, /* INPUT */int write_response_ready_delay, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_resp_channel_phase_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_resp_channel_phase_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *resp, /* OUTPUT */int *write_response_ready_delay, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_addr_channel_cycle_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *region, const /* INPUT */svBitVecVal *cache, const /* INPUT */svBitVecVal *burst_length, const /* INPUT */svBitVecVal *size, const /* INPUT */svBitVecVal *burst, const /* INPUT */svBitVecVal *lock, const /* INPUT */svBitVecVal *qos, const /* INPUT */svBitVecVal *prot, 
/* INPUT */int _unit_id);

 extern void dvc_axi4_read_addr_channel_cycle_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_addr_channel_cycle_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *cache, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *qos, 
/* OUTPUT */svBitVecVal *prot, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_addr_channel_ready_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char ready, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_addr_channel_ready_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */unsigned char *ready, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_channel_cycle_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *resp, /* INPUT */unsigned char last, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_channel_cycle_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_channel_cycle_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *resp, /* OUTPUT */unsigned char *last, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_read_channel_ready_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char ready, /* INPUT */int _unit_id);

 extern void dvc_axi4_read_channel_ready_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */unsigned char *ready, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_addr_channel_cycle_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *region, const /* INPUT */svBitVecVal *cache, const /* INPUT */svBitVecVal *burst_length, const /* INPUT */svBitVecVal *size, const /* INPUT */svBitVecVal *burst, const /* INPUT */svBitVecVal *lock, const /* INPUT */svBitVecVal *qos, const /* INPUT */svBitVecVal *prot, 
/* INPUT */int _unit_id);

 extern void dvc_axi4_write_addr_channel_cycle_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_addr_channel_cycle_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *region, /* OUTPUT */svBitVecVal *cache, /* OUTPUT */svBitVecVal *burst_length, /* OUTPUT */svBitVecVal *size, /* OUTPUT */svBitVecVal *burst, /* OUTPUT */svBitVecVal *lock, /* OUTPUT */svBitVecVal *qos, 
/* OUTPUT */svBitVecVal *prot, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_addr_channel_ready_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char ready, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_addr_channel_ready_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */unsigned char *ready, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_channel_cycle_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char last, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_channel_cycle_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_channel_cycle_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */unsigned char *last, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_channel_ready_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char ready, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_channel_ready_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */unsigned char *ready, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_resp_channel_cycle_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, const /* INPUT */svBitVecVal *resp, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_resp_channel_cycle_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */int *_trans_id, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_resp_channel_cycle_ReceivedReceivingReceive_open_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */int _trans_id, /* OUTPUT */svBitVecVal *resp, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_write_resp_channel_ready_SendSendingSent_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* INPUT */unsigned char ready, /* INPUT */int _unit_id);

 extern void dvc_axi4_write_resp_channel_ready_ReceivedReceivingReceive_SystemVerilog(/* INPUT */int _comms_semantic, /* INPUT */long long _as_end, /* OUTPUT */unsigned char *ready, /* INPUT */int _unit_id, /* INPUT */unsigned char _using);

 extern void dvc_axi4_fn_get_raddr_phase_info(/* INOUT */unsigned char *valid, const /* INPUT */svBitVecVal *id, /* OUTPUT */int *num_beats_rcvd);

 extern void dvc_axi4_fn_get_waddr_phase_info(/* INOUT */unsigned char *valid, const /* INPUT */svBitVecVal *id);

 extern void dvc_axi4_fn_add_addr_map_entry(/* INPUT */const char* region, /* INPUT */unsigned long long size);

 extern void dvc_axi4_fn_add_wr_delay(/* INPUT */const char* region, const /* INPUT */svBitVecVal *id, /* INPUT */unsigned int addr2data, /* INPUT */int data2data_DIMS0);

 extern void dvc_axi4_fn_delete_wr_delay(/* INPUT */const char* region, const /* INPUT */svBitVecVal *id);

 extern void dvc_axi4_fn_drive_signals(/* INPUT */const char* signal, /* INPUT */long long value);

 extern void dvc_axi4_fn_set_address_map_entry();

 extern void dvc_axi4_fn_set_wr_def_delays(/* INPUT */unsigned int min_addr2data, /* INPUT */int min_data2data_DIMS0, /* INPUT */unsigned int max_addr2data, /* INPUT */int max_data2data_DIMS0);

 extern void dvc_axi4_fn_print_perf_stats();

 extern void dvc_axi4_unblock_SystemVerilog(/* INPUT */unsigned int id);

 extern void dvc_axi4_wait_for();

 extern void dvc_axi4_block_SystemVerilog(/* INPUT */unsigned int id);
void SdisableFork();

#ifdef __cplusplus
}
#endif


#endif //#ifndef _VC_HDRS_H

